<?php

require_once "exComponent/table/ListTable.php";
require_once XOOPS_ROOT_PATH."/modules/addbook/admin/default/forms/ItemListFilter.class.php";

define('ITEMLISTTABLE_PERPAGE',20);

class ItemListTableComponent extends exListTableComponent
{
	function ItemListTableComponent()
	{
		parent::exListTableComponent(null,null);
	}
	
	function init($filter=null)
	{
		if(!$filter)
			$filter = new ItemTableModel();
		parent::init($filter);
	}
}

class ItemTableModel extends exListTableModel
{
	var $_column_ = array ( "ITEMID","ITEMNAME","ITEMDESC","FORMTYPE","FORMMAX","FORMLENGTH","FORMDEFAULT","FORMOPTIONS","TABLENAME","WEIGHT",'VISIBLE_L','VISIBLE_E' /* ,"ACTION" */ );

	function ItemTableModel($component=null)
	{
		parent::exListTableModel($component);
		$this->filter_ = new ItemListFilter();
	}

	function init()
	{
		$handler=&addbook::getHandler('item');
		
		$this->listController_ = new ListController();
		$this->listController_->filter_=&$this->filter_;
		$this->listController_->filter_->fetch();
		$this->listController_->fetch($handler->getCount($this->listController_->filter_->getCriteria()),ITEMLISTTABLE_PERPAGE);

		$objs = $handler->getObjects($this->listController_->getCriteria());
		foreach($objs as $obj) {
			$this->_row_data_[]=$obj->getStructure();
		}
		
		return COMPONENT_MODEL_INIT_SUCCESS;
	}

	/*
	function getValueAtAction($arr)
	{
	}
	*/

	// --------------------------------------------------------------------
	// GetValue Callback
	// üɽפʥ᥽åɤϥǥեȤεưǤƤɤɤäƤ
	// --------------------------------------------------------------------
	function getValueAtItemid($arr)
	{
		return $arr['itemid'];
	}

	function getValueAtItemname($arr)
	{
		return $arr['itemname'];
	}

	function getValueAtItemdesc($arr)
	{
		return $arr['itemdesc'];
	}

	function getValueAtFormtype($arr)
	{
		return $arr['formtype'];
	}

	function getValueAtFormmax($arr)
	{
		return $arr['formmax'];
	}

	function getValueAtFormlength($arr)
	{
		return $arr['formlength'];
	}

	function getValueAtFormdefault($arr)
	{
		return $arr['formdefault'];
	}

	function getValueAtFormoptions($arr)
	{
		return $arr['formoptions'];
	}

	function getValueAtTablename($arr)
	{
		return $arr['tablename'];
	}

}

?>