<?php

require_once "xoops/object.php";

class addbookItemObject extends exXoopsObject {
	function addbookItemObject($id=null)
	{
		$this->initVar('itemid', XOBJ_DTYPE_INT, 0, true);
		$this->initVar('itemname', XOBJ_DTYPE_TXTBOX, null, true, 255);
		$this->initVar('itemdesc', XOBJ_DTYPE_TXTAREA, null, false, null);
		$this->initVar('formtype', XOBJ_DTYPE_TXTBOX, null, false, 255);
		$this->initVar('formmax', XOBJ_DTYPE_INT, 255, false);
		$this->initVar('formlength', XOBJ_DTYPE_INT, 30, false, 10);
		$this->initVar('formdefault', XOBJ_DTYPE_TXTBOX, null, false, 255);
		$this->initVar('formoptions', XOBJ_DTYPE_TXTAREA, null, false, null);
		$this->initVar('tablename', XOBJ_DTYPE_TXTBOX, null, true, null);
		$this->initVar('weight', XOBJ_DTYPE_TXTBOX, null, false, null);
		$this->initVar('visible_l', XOBJ_DTYPE_INT, 1, false, null);
		$this->initVar('visible_e', XOBJ_DTYPE_INT, 1, false, null);

		if ( is_array ( $id ) )
			$this->assignVars ( $id );
	}

	/// Database Connect Model
	function &getTableInfo()
	{
		$tinfo = new exTableInfomation('addbook_item','itemid');
		return ($tinfo);
	}
}

class addbookItemObjectHandler extends exXoopsObjectHandler{
	// constructor
	function addbookItemObjectHandler(){
		global $xoopsDB ;
		$class = 'addbookItemObject' ;
		$this->exXoopsObjectHandler($xoopsDB,$class) ;
	}	

	// ñ˥ơ֥륢ƥǤϤʤơ֥뤬AΤȤjoin_itemBΤĥäƤ
	function getItemObjects($table=false){
		global $xoopsModuleConfig ;
		
		$criteria = new CriteriaCompo();
		if($table != false){
			$criteria_tbl = new CriteriaCompo(new Criteria('tablename',strtolower($table))) ;
			if( strtolower($table)=='a' && $xoopsModuleConfig['join_item']){
				$criteria_tbl->add(new Criteria('itemid',$xoopsModuleConfig['join_item']), 'or') ;
			}
			$criteria->add($criteria_tbl);
		}
		$criteria->add(new Criteria('visible_e', '1')) ;
		$criteria->setSort('weight');
		$item_objs =& $this->getObjects($criteria);
		return $item_objs ;				
	}
	
}
?>