<?php
require_once 'xoops/perm.php';
require_once 'include/addbook_gperm.php' ;
require_once XOOPS_ROOT_PATH."/modules/addbook/default/forms/ValueEditForm.class.php";

class default_DefaultIndexAction extends mojaLE_AbstractAction
{
	function execute(&$controller,&$request,&$user)
	{
		global $xoopsModuleConfig ;
		
		// VIEWؤΥե饰
		$action_flag = array(
			'do_search' => false , // 򤷤ɤ
//			'has_result' => false , // ̤뤫ɤ
			);

		// 4ĤGET
		$tbl = isset($_GET['tbl']) ? $_GET['tbl'] : '' ;
		$condition = isset($_GET['condition']) ? $_GET['condition'] : 'and' ;
		$rownum = isset($_GET['rownum']) ? intval($_GET['rownum']) : 20 ;
		$start = isset($_GET['start']) ? intval($_GET['start']) : 0 ;
		
		// ActionForm˸ܤ
		$editform =& new ValueEditForm();
		$editform->tbl = $tbl ;
		$editform->condition = $condition ;
		$editform->rownum = $rownum ;
		$editform->start = $start ;
		// Ƥιܤ$editformload
		$editform->load_property(true);

		// GETǤfetch
		$dummy = null ;
		$editform->fetch($dummy, $request);

		// 쥯ȥ֤뤿Υǡ
		// ϥɥμ
		$item_handler=&addbook::getHandler('item');
		$valueA_handler=& addbook::getHandler('valueA');
		$valueB_handler=& addbook::getHandler('valueB');
		$handler_ref = array('item'=>$item_handler, 'valueA'=>$valueA_handler , 'valueB'=>$valueB_handler) ;
		// ܰμ
		$criteria =& new CriteriaCompo( new Criteria('visible_l','1'));
		$visible_item_objs = $item_handler->getObjects($criteria);
        // ѹܰμ
		if($xoopsModuleConfig['search_item_type']=='select'){
			$item_objs = array();
			foreach($visible_item_objs as $visible_item_obj){
				if( preg_match('/(select|radio)/', $visible_item_obj->getVar('formtype')) ){
					$item_objs[] = $visible_item_obj;
				}
			}
		}else{
			$item_objs =& $visible_item_objs ;	
		}
		// ܤΥ쥯ȥ֤μ
		list($select_item, $select_caption) = $this->_getSelectItemTab($item_objs , $handler_ref) ;
		$request->setAttribute('select_item', $select_item);
		$request->setAttribute('select_caption', $select_caption);

		// Ԥ -- 
		// ʤȤơ֥̾ʤиϤǤʤ
		if($editform->tbl!='a' && $editform->tbl!='b'){
			$request->setAttribute('action_flag',$action_flag);
			$request->setAttribute('editform',$editform);
			return VIEW_SUCCESS ;	
		}else{
			$action_flag['do_search'] = true ; 
		}
		
		// ɽԤܤ
		$item_criteria = new Criteria('visible_l',1);
		$item_criteria->setSort('weight');
		$visible_items =& $item_handler->getObjects($item_criteria);
		$request->setAttribute('visible_items',$visible_items);
		
		// ơ֥˰ͤäơϥɥѤ
		$search_h = $editform->tbl=='a' ? $valueA_handler : $valueB_handler ;

		// ܤθgid˹Ԥ
		list($all_search, $gid_num, $gid) = $this->_getSearchGid($editform, $visible_item_objs, $search_h) ;

		// (gidɽѥǡ)
//		$action_flag['has_result'] = true ;	
		$data_criteria =& new CriteriaCompo();
		$data_criteria->setSort('gid');
		if(!$all_search){ // ︡SQLǷ椷ƤΤ
			$gid = array_slice($gid, $editform->start, $editform->rownum);
		}
		foreach($gid as $key=>$value){
			$data_criteria->add(new Criteria('gid',$value), 'or');
		}
		$search_results =& $search_h->getObjects($data_criteria);
		$request->setAttribute('search_results', $search_results) ;
		// Ԥ -- ޤ
		$request->setAttribute('gid_num', $gid_num);
		$request->setAttribute('action_flag',$action_flag);
		$request->setAttribute('editform',$editform);
		
		// ԽܥΤ˸¥å
		$priv = array();
		$priv['edit'] = exPerm::isPerm('addbook_global', GPERM_EDITABLE);
		$priv['delete'] = exPerm::isPerm('addbook_global', GPERM_DELETEABLE);
		$request->setAttribute('priv',$priv);

		return VIEW_SUCCESS;
	}




	function isSecure()
	{
		return true;
	}



	
	// ܤΥ쥯ȥ֤μ -- 
	function _getSelectItemTab($item_objs , $handler_ref){
		
		global $xoopsModuleConfig ;
		
		// ɽܤ
		$select_item = array();
		$select_caption = array();
		foreach($item_objs as $item){
			// checkboxϳ
			if($item->getVar('formtype')=='checkbox'){
				continue;	
			}
			$tablename = $item->getVar('tablename','e') ;
			if( strtolower($tablename) == 'a'){
				$v_handler =& $handler_ref['valueA'] ;
			}elseif( strtolower($tablename) == 'b'){
				$v_handler =& $handler_ref['valueB'] ;
			}
			// ǡäƤ
			$itemid = $item->getVar('itemid','e') ;
			$itemname = $item->getVar('itemname','e') ;
			$distinct_array = $v_handler->getDistinctValue('addbook_value'.strtoupper($tablename),$itemid) ;
			// ȤǼ
			$select_item[$tablename][$itemid] = $distinct_array ;
			$select_caption[$itemid] = $itemname ; 
		}
		// 祭B->Aˤ⥳ԡ
		if($xoopsModuleConfig['join_item']){
			// ԡǤСΤޤޥåȡǤʤϼäƤ
			$select_item['a'][$xoopsModuleConfig['join_item']] = 
				isset($select_item['b'][$xoopsModuleConfig['join_item']]) ?
					$select_item['b'][$xoopsModuleConfig['join_item']] :
					$handler_ref['valueB']->getDistinctValue('addbook_valueB',$xoopsModuleConfig['join_item']);
			// ץ̾
			$item_handler =& $handler_ref['item'];
			$join_item_obj =& $item_handler->get($xoopsModuleConfig['join_item']);
			$select_caption[$xoopsModuleConfig['join_item']] = $join_item_obj->getVar('itemname');
		}
		// ܤΥ쥯ȥ֤μ -- ޤ
		$return_array = array($select_item, $select_caption) ;
		return $return_array ;
	}
	



	
	// 2ʳǽʳgidؿ
	function _getSearchGid($editform, $visible_item_objs , $search_h){
		// ܤθgid˹Ԥ
		// Criteria(ޤgidΤߤȤ)
		// vitemidvisible_l1ΤΤcriteria
		$search_criteria_vitemid =& new CriteriaCompo();
		foreach($visible_item_objs as $visible_item){ // ֥κ
//			if($visible_item->getVar('tablename')==$editform->tbl) // join_itemʤ
			$search_criteria_vitemid->add(new Criteria('vitemid',$visible_item->getVar('itemid')),'or');
		}

		$search_gid = array();
		$all_search = true ; // ɽե饰
		foreach($editform->items as $itemid){
			$prop = $itemid.'_';
			if(!empty($editform->$prop)){
				$all_search = false ;
				$search_criteria_gid =& new CriteriaCompo();
				$search_criteria_gid->setSort('gid');
				$search_criteria_gid->setGroupby('gid');
				$search_criteria_gid->add($search_criteria_vitemid);
				$search_criteria_gid->add(new Criteria('vitemid', $itemid)) ;
				$search_criteria_gid->add(new Criteria('value', $editform->$prop)) ;
				$search_gid[$itemid] = array();
				$tmp_v_objs =& $search_h->getObjects($search_criteria_gid) ;
				foreach($tmp_v_objs as $v_obj){
					$tmp_gid = intval($v_obj->getVar('gid'));
					$search_gid[$itemid][$tmp_gid] = $tmp_gid ;
				}
			}
		}
		// ɽλϡ嵭getObjects˹ԤʤΤ
		if($all_search){
			$gid = array();
			$all_search_criteria =& new Criteria('1',1);
			$all_search_criteria->setSort('gid');
			$all_search_criteria->setGroupby('gid');
			$all_search_criteria->setStart($editform->start);
			$all_search_criteria->setLimit($editform->rownum);
			$tmp_v_objs =& $search_h->getObjects($all_search_criteria);
			foreach($tmp_v_objs as $v_obj){
				$tmp_gid = intval($v_obj->getVar('gid'));
				$gid[$tmp_gid] = $tmp_gid ;
			}
			// 
			$gidnum_criteria =& new Criteria('1','1');
			$gidnum_criteria->setGroupby('gid');
			$gid_num = intval($search_h->getRowNum($gidnum_criteria));
		}else{
			// ä$search_gidconditionˤarray_intersect or array_mergeФ
			$array_func = $editform->condition=='and' ? 'array_intersect' : 'array_merge' ;
			$gid = $search_gid[key($search_gid)] ;
			foreach($search_gid as $gid_array){
				$gid = $array_func($gid, $gid_array) ;
			}
			$gid = array_unique($gid);
			// 
			$gid_num = count($gid) ;
		}
		
		$return_array = array($all_search, $gid_num, $gid) ;
		return $return_array ;
	}
}

?>