<?php
require_once XOOPS_ROOT_PATH."/class/xoopsform/formelement.php";
require_once XOOPS_ROOT_PATH."/class/xoopsform/formselect.php";

class default_DefaultindexView_success extends mojaLE_AbstractView
{
	function &execute (&$controller, &$request, &$user)
	{
		global $xoopsModuleConfig ;
		
		$renderer = new mojaLE_XoopsTplRenderer($controller,$request,$user);
		$renderer->setTemplate('addbook_defaultindex_success.html');
		$renderer->setAttribute('tableA_name',$xoopsModuleConfig['tableA_name']);
		$renderer->setAttribute('tableB_name',$xoopsModuleConfig['tableB_name']);

		$editform =& $request->getAttribute('editform');
		$action_flag =& $request->getAttribute('action_flag');

		// 쥯ȥ֤XoopsFormSelectѤƥХХ
		$select_item = $request->getAttribute('select_item') ;
		$select_caption = $request->getAttribute('select_caption') ;
		$select_tab =& $this->_create_AddbookSearchSelecttab($editform, $select_item, $select_caption);
		$renderer->setAttribute('select_tab', $select_tab);

		// ̤С˥
		$gid_num =& $request->getAttribute('gid_num'); // 
		if($action_flag['do_search']==false){ // ΤΤ򤷤Ƥʤ
			return $renderer ;	
		}
		// Ϥޤե饰
		$renderer->setAttribute('do_search', true);
		if($gid_num == 0){
			return $renderer ;	
		}else{
			$search_items =& $request->getAttribute('visible_items');
			$search_results =& $request->getAttribute('search_results');
			if(is_array($search_results)){
				// ǡΥ
				$data = $this->_render_ValueData($editform, $search_results);
				// ̾Υ
				$item = array();
				foreach($search_items as $i_obj){
					if($i_obj->getVar('tablename') == $editform->tbl || 
						$i_obj->getVar('itemid') == $xoopsModuleConfig['join_item']){
						$item[$i_obj->getVar('itemid')] = $i_obj->getVar('itemname') ;
					}
				}
				// ǽԽ
				if($xoopsModuleConfig['show_lastupdate'] === 1){
					$item['lastupdate'] = _MD_ADDBOOK_LANG_LAST_UPDATE; }
				$priv = $request->getAttribute('priv');
				if($priv['edit']){
					$item['edit'] = _EDIT; }
				if($priv['delete']){
					$item['delete'] = _DELETE; }
				
				// ڡκ
				$nav =& $this->_create_AddbookPageNav($editform, $gid_num) ;
		       	$renderer->setAttribute('page_navi',$nav->renderNav(4)); 

#var_dump($gid_num);
				$renderer->setAttribute('search_num', $gid_num);
				$renderer->setAttribute('search_data', $data);
				$renderer->setAttribute('search_item', $item);
			}
			return $renderer;
		}
	}
	
	
	
	// select֤
	function _create_AddbookSearchSelecttab($editform, $select_item, $select_caption){

		$select_tab = array();
		foreach($select_item as $tablename=>$items){
			foreach($items as $itemid=>$values){
				$itemid_ = $itemid.'_';
				$select_form =& new XoopsFormSelect(
									'dummycaption' ,
									$itemid ,
									$editform->$itemid_
									);
				// $values˶ǡ̵Ƭ
				if( ! in_array('', $values)){
					array_unshift($values, '');
				}
				foreach($values as $key=>$value){
					$label = empty($value) ? '----' : $value ;
					$select_form->addOption( $value, $label );
				}
				// ޤȤ
				$select_tab[$tablename][$itemid] = array(
					'tab' => $select_form->render(),
					'caption' => $select_caption[$itemid],
				        'itemid' => $itemid
					);
			}
		}
		// And/ORɽΥ쥯ȥ
		$select_form =& new XoopsFormSelect('dummycaption', 'condition', $editform->condition);
		$select_form->addOptionArray(array('and'=>'and', 'or'=>'or'));
		$select_tab['condition'] = $select_form->render();
		$select_form =& new XoopsFormSelect('dummycaption', 'rownum', $editform->rownum);
		$select_form->addOptionArray(array('10'=>'10','20'=>'20','30'=>'30','50'=>'50','100'=>'100'));
		$select_tab['rownum'] = $select_form->render();

		return $select_tab ;
	}	

	// valueǡ򥪥֥Ȥ˥
	function _render_ValueData($editform, $search_results){
		global $xoopsModuleConfig ;
		$data =	array();
		foreach($search_results as $v_obj){
			$gid = $v_obj->getVar('gid');
			// join_itemˤϥ󥯤Ĥ
			$value = $v_obj->getVar('value','n') ;
			if($v_obj->getVar('vitemid')==$xoopsModuleConfig['join_item']){
				$flip_tbl = ($editform->tbl=='a') ? 'b' : 'a' ; 
				$value = sprintf('<a href="%s/modules/addbook/index.php?action=DefaultIndex&tbl=%1s&%d=%s">%s</a>', 
									XOOPS_URL, $flip_tbl, $v_obj->getVar('vitemid'), urlencode($value), $value) ;
			}
			$data[$gid][$v_obj->getVar('vitemid')] = $value ;
			// ǽԽ
			$data[$gid]['lastupdate'] = date(_MD_ADDBOOK_FORMAT_YDMHIS, $v_obj->getVar('submittime'));// ʤ
			$data[$gid]['edit'] = sprintf('<a href="%s/modules/addbook/?action=value_edit&gid=%d&tbl=%s">%s</a>',XOOPS_URL , $gid, $editform->tbl, _EDIT ); // ʤ
			$data[$gid]['delete'] = sprintf('<a href="%s/modules/addbook/?action=value_delete&gid=%d&tbl=%s">%s</a>',XOOPS_URL , $gid, $editform->tbl, _DELETE); // ʤ
		}
		return $data ;
	}
		
	


	// ڡ
	function _create_AddbookPageNav($editform, $gid_num){
		$page_query = sprintf('action=defaultindex&amp;rownum=%d&amp;tbl=%1s', $editform->rownum, $editform->tbl) ;
		foreach($editform->items as $itemid){
			$prop = $itemid.'_';
			if(!empty($editform->$prop)){
				$s_query = urlencode(htmlspecialchars($editform->$prop));
				$page_query.= sprintf('&amp;%d=%s', $itemid, $s_query) ;
			}
		}
		require_once XOOPS_ROOT_PATH.'/class/pagenav.php';
		$nav =& new XoopsPageNav( $gid_num , $editform->rownum , $editform->start , 'start' , $page_query ) ;
		return $nav ;		
	}
}

?>