<?php

require_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";
require_once XOOPS_ROOT_PATH."/modules/addbook/include/addbook_util.php";

class default_Value_editView_input extends mojaLE_AbstractView
{
	function &execute (&$controller, &$request, &$user)
	{
		global $xoopsModuleConfig ;
		
		// ActionFormǰƤͤμ
		$editform=&$request->getAttribute('editform'); 
		// ޤեޤ
		$xmc_tbl_nm = sprintf('table%s_name', strtoupper($editform->tbl)) ;
		$value_edit_title = sprintf(_MD_ADDBOOK_LANG_VALUE_EDIT_TITLE, $xoopsModuleConfig[$xmc_tbl_nm]);
		$form = new XoopsThemeForm($value_edit_title,'Value_edit_label','','POST');
		// gid/tableƤޤ
		$form->addElement(new XoopsFormHidden('gid',$editform->gid_));
		$form->addElement(new XoopsFormHidden('tbl',$editform->tbl));

		// ƥäƤ
		$handler=&addbook::getHandler('item');
		$item_objs =& $handler->getItemObjects($editform->tbl);
		foreach($item_objs as $item){
			// ɽܤpass
			if( ! $item->getVar('visible_e')){
				continue ;
			}
			// ܤɽ
			$_prop_name = $item->getVar('itemid','n') . '_' ;
			//// ǼͤArrayΤΤserialize
			$form_var = isset($editform->$_prop_name) ? $editform->$_prop_name : $item->getVar('formdefault','e') ;
			if($unserialize_form_var = @unserialize($form_var)){
				$form_var = $unserialize_form_var ;
			}else{
				$form_var = htmlspecialchars($form_var);
			}
			// BȤΥ֥åܤϥǡ򥻥쥯ȥ֤ǽФ
			if( strtolower($editform->tbl)=="a" && 
				$item->getVar('itemid','n')==$xoopsModuleConfig['join_item'] && 
				$item->getVar('tablename','e')=='b' ){

				// addbook_valueBơ֥뤫ϿѤߤͤꡢ쥯ȥ֤
				$valueB_values = array();
				$valueB_handler =& addbook::getHandler('valueB');
				$joindata = $valueB_handler->getDistinctValue('addbook_valueB',$xoopsModuleConfig['join_item']);
				foreach($joindata as $data){
					$valueB_values[$data] = $data ;
				}
				$new_form =& new XoopsFormSelect(
							$item->getVar('itemname','e') ,
							$item->getVar('itemid', 'e') ,
							$form_var
				);
				$new_form->addOptionArray($valueB_values);
				$form->addElement($new_form);

				continue ;		
			}
			// main
			switch($item->getVar('formtype','e')){
				case 'text' :
					$new_form =& new XoopsFormText(
								$item->getVar('itemname','e') , /* CAPTION */
								$item->getVar('itemid','e'),  /* name */
								$item->getVar('formlength','e'), /* size */
								$item->getVar('formmax','e'), /* max */
								$form_var 
								) ;
				break ;

				case 'textarea' :
					$new_form =& new XoopsFormTextArea(
								$item->getVar('itemname','e') ,
								$item->getVar('itemid','e'),  /* name */
								$form_var ,
								$item->getVar('formlength','e'), /* size */
								$item->getVar('formmax','e') /* max */
								) ;
				break ;

				case 'Dtextarea' :
					$new_form =& new XoopsFormDhtmlTextArea(
								$item->getVar('itemname','e') ,
								$item->getVar('itemid','e'),  /* name */
								$form_var ,
								$item->getVar('formlength','e'), /* size */
								$item->getVar('formmax','e') /* max */
								) ;
				break ;
				
				case 'checkbox' :
				case 'select' :
				case 'radio' :
					switch($item->getVar('formtype','e')){
						case 'checkbox' :
							$new_form_class = 'XoopsFormCheckBox' ;
						break ;	
						case 'select' :
							$new_form_class = 'XoopsFormSelect' ;
						break ;						
						case 'radio' :
							$new_form_class = 'XoopsFormRadio' ;
						break ;						
					}
					$new_form =& new $new_form_class(
								$item->getVar('itemname','e') ,
								$item->getVar('itemid', 'e') ,
								$form_var 
								);
					$options = AddbookUtil::Str2FormOptionsArray($item->getVar('formoptions','n'));
					foreach($options as $value=>$label){
						$new_form->addOption( $value,$label );
					}
				break ;

			}
			$form->addElement( $new_form );
		}

		$tray = new XoopsFormElementTray('<!-- CAPTION -->');
		// submit ܥ
		$tray->addElement( new XoopsFormButton ( /* CAPITON(NO REQUIRED) */ '', 'submit', '*SUBMIT*', 'submit' ) );
		// delete ܥ
//		$tray->addElement( new XoopsFormButton ( /* CAPITON(NO REQUIRED) */ '', 'delete', '*DELETE*', 'submit' ) );
		$form->addElement($tray);
		
		$renderer = new mojaLE_XoopsTplRenderer($controller,$request,$user);
		$renderer->setTemplate('addbook_value_edit_input.html');

		$renderer->setAttribute('form',$form->render());

		return $renderer;
	}
}

?>