<?php

// <--- BASIC PROPERTY --->
$modversion['name'] = _MI_ADDBOOK_NAME;
$modversion['version'] = 0.10;
$modversion['description'] = _MI_ADDBOOK_NAME_DESC;

$modversion['credits'] = "XOOPS Tohokuaiki modules";
$modversion['author'] = "ITOH Takashi<br />http://xoopsdevelopment.tohokuaiki.jp" ;
$modversion['license'] = "GPL2";
$modversion['official'] = 0;
$modversion['image'] = "images/addbook.png";
$modversion['dirname'] = "addbook";

// <--- TEMPLATE PROPERTY --->
$modversion['use_smarty']=1;
$modversion['templates'][0]['file'] = 'addbook_defaultindex_success.html';
$modversion['templates'][0]['description'] = '';
$modversion['templates'][1]['file'] = 'addbook_value_edit_input.html';
$modversion['templates'][1]['description'] = '';
$modversion['templates'][2]['file'] = 'addbook_value_delete_input.html';
$modversion['templates'][2]['description'] = '';
$modversion['templates'][3]['file'] = 'addbook_value_editindex_success.html';
$modversion['templates'][3]['description'] = '';

// <--- BLOCK PROPERTY --->
// $modversion['blocks'][1]['file'] = '';
// $modversion['blocks'][1]['name'] = _MI_ADDBOOK_BNAME1;
// $modversion['blocks'][1]['show_func'] = '';
// $modversion['blocks'][1]['template'] = '';

// <--- SQL PROPERTY --->
$modversion['sqlfile']['mysql']='sql/mysql.sql';
$modversion['tables'][0] = 'addbook_item';
$modversion['tables'][1] = 'addbook_valueA';
$modversion['tables'][2] = 'addbook_valueB';

// <--- ADMIN PROPERTY --->
$modversion['hasAdmin'] = 1;
$modversion['adminindex'] = "admin/index.php";
$modversion['adminmenu'] = "admin/menu.php";


// <--- MENU PROPERTY --->
$modversion['hasMain'] = 1;
$modversion['sub'][1] = array(
    'name' => _MI_ADDBOOK_BASIC_SUBMENU_VALUE_EDIT ,
    'url' => 'index.php?action=value_editindex',
    );

// <--- CONFIG PROPERTY --->
// $modversion['config'][1]['name']='';
// $modversion['config'][1]['title']='_MI_ADDBOOK_XXX';
// $modversion['config'][1]['description']='_MI_ADDBOOK_XXX_DESC';
// $modversion['config'][1]['formtype']='';
// $modversion['config'][1]['valuetype']='';
// $modversion['config'][1]['default']="";


$modversion['config'] = array() ;
// get tableB item
$tableB_items = array('no use'=>'0');
global $xoopsDB;
$sql = sprintf('select itemid,itemname from %s where tablename="b" order by weight', $xoopsDB->prefix('addbook_item'));
$re = $xoopsDB->query($sql);
while($r=$xoopsDB->fetchArray($re)){
    $tableB_items[$r['itemname']] = $r['itemid'];
}
$modversion['config'][1] = array(
	'name' => 'join_item',
	'title' => '_MI_ADDBOOK_BASIC_JOIN_KEY',
	'description' => '_MI_ADDBOOK_BASIC_JOIN_KEY_DSC',
	'formtype' => 'select',
	'valuetype' => 'text',
	'default' => '0',
        'options' => $tableB_items,
) ;
$modversion['config'][] = array(
	'name' => 'tableA_name',
	'title' => '_MI_ADDBOOK_BASIC_TABLEA_NAME',
	'description' => '_MI_ADDBOOK_BASIC_TABLEA_NAME_DSC',
	'formtype' => 'textbox',
	'valuetype' => 'text',
	'default' => _MI_ADDBOOK_BASIC_TABLEA_DEFAULT,
) ;
$modversion['config'][] = array(
	'name' => 'tableA_desc',
	'title' => '_MI_ADDBOOK_BASIC_TABLEA_DESC',
	'description' => '_MI_ADDBOOK_BASIC_TABLE_DESC_D',
	'formtype' => 'textarea',
	'valuetype' => 'text',
	'default' => '',
) ;
$modversion['config'][] = array(
	'name' => 'tableB_name',
	'title' => '_MI_ADDBOOK_BASIC_TABLEB_NAME',
	'description' => '_MI_ADDBOOK_BASIC_TABLEB_NAME_DSC',
	'formtype' => 'textbox',
	'valuetype' => 'text',
	'default' => _MI_ADDBOOK_BASIC_TABLEB_DEFAULT,
) ;
$modversion['config'][] = array(
	'name' => 'tableB_desc',
	'title' => '_MI_ADDBOOK_BASIC_TABLEB_DESC',
	'description' => '_MI_ADDBOOK_BASIC_TABLE_DESC_D',
	'formtype' => 'textarea',
	'valuetype' => 'text',
	'default' => '',
) ;
$modversion['config'][] = array(
	'name' => 'search_item_type',
	'title' => '_MI_ADDBOOK_BASIC_SEARCH_ITEM',
	'description' => '_MI_ADDBOOK_BASIC_SEARCH_ITEM_D',
	'formtype' => 'select',
	'valuetype' => 'text',
	'options' => array('radio/select'=>'select','all'=>'all'),
	'default' => 'select',
) ;
$modversion['config'][] = array(
	'name' => 'show_lastupdate',
	'title' => '_MI_ADDBOOK_BASIC_SHOW_LASTUP',
	'description' => '_MI_ADDBOOK_BASIC_SHOW_LASTUP_D',
	'formtype' => 'yesno',
	'valuetype' => 'int',
	'default' => '1',
) ;
$modversion['config'][] = array(
	'name' => 'data_implode_str',
	'title' => '_MI_ADDBOOK_BASIC_DATA_IMP_STR',
	'description' => '_MI_ADDBOOK_BASIC_DATA_IMP_STR_D',
	'formtype' => 'textbox',
	'valuetype' => 'text',
	'default' => '&nbsp;/&nbsp;',
) ;

// Comments
$modversion['hasComments'] = 0;

// Notifications
$modversion['hasNotification'] = 0;
?>