<?php
/**
@file
@brief exDynaActionForm ѤΥեɥץѥƥ˴ؤ륯饹Ƥե
@author minahito
@version $Id$

\section copyright Copyright and license
 Copyright (c) 2003-2004, minahito
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

1 Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer.

2 Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

3 Neither the name of the nor the names of its contributors may be used to 
  endorse or promote products derived from this software without specific 
  prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 SUCH DAMAGE.
*/

/**
@brief եɥץѥƥ򤷤᤹ȥ饯㡼
@attention ƥץѥƥؤϥ᥽åɤľܻѤʤǲ
           ä vars бɬפꡢͤѤǽؤ礭ꥹǤ
*/
class exDynaActionFormFieldProperty
{
	var $property_;				///< ץѥƥ̾Ρ
	var $depends_ = array();		///< 롼Υ쥯(HashMap)
	var $msg_ = array();			///< åΥ쥯
	var $vars_ = array();			///< ѿͤΥ쥯(HashMap)

	/**
	@brief 󥹥ȥ饯
	@param $name ץѥƥ̾Ρproperty_ ץѥƥ˳Ǽޤ
	*/
	function exDynaActionFormFieldProperty($name)
	{
		$this->property_ = $name;
	}

	/**
	@brief $name  exDynaActionFormDependProperty 饹Υ󥹥󥹤
           depens_ץѥƥɲäޤ
	@param $name string
	@return $name Ϳ줿 validation 롼뤬¸ߤʤä硢 null ᤷޤ
	@note validation 롼ϳɲòǽȤ뤿ᡢǤü̿̾§˴Ťƥ饹̾
	      Υ饹̾ǥ֥ȤƤޤ̿̾§ϡ
	      \code
	      $classname = "exDynaFieldDepend".ucfirst(strtolower($name));
	      \endcode
	      Ǥ
	@attention ̿̾§ѹǽΤǡߤϤ validation ɲäѤ뤳ȤϡꥹǤ
	*/
	function addDepend($name)
	{
		$classname = "exDynaFieldDepend".ucfirst(strtolower($name));
		if(class_exists($classname)) {
			$depend = new $classname();
			$this->depends_[]=&$depend;
			return true;
		}
		else {
			return false;
		}
	}
	
	/**
	@brief åɲäޤץѥƥ msg_ ˥ϥåޥåפȤѤޤޤ
	@param $message exDynaFieldMessage 󥹥
	*/
	function addMsg(&$message)
	{
		$this->msg_[$message->name_] = $message;
		// print $this->msg_[$name]."<br/>\n";
	}
	
	/**
	@brief $name Ȥ˥åᤷޤ
	@param $name å̾
	@return string
	*/
	function getMsg($name)
	{
		return $this->msg_[$name];	///< @todo isset ɬפ
	}
	
	/**
	@brief ѿͤɲäޤץѥƥ vars_ ˥ϥåޥåפȤѤޤޤ
	@param $key ѿΥ
	@param $value ѿ
	@deprecated
	*/
	function addVar($key,$value)
	{
		$this->vars_[$key]=$value;
	}
	
	/**
	@brief $key ѿͤᤷޤ
	@param $key ѿΥ
	@return ͤƤʤȤ null ᤷޤ
	*/
	function getVar($key)
	{
		return isset($this->vars_[$key]) ? $this->vars_[$key] : null;
	}
	
	/**
	@brief depend 롼˴Ť¹Ԥ롣
	@param $form exDynaActionForm
	@note exDynaActionForm ꥳ뤵롣
	*/
	function validate(&$form)
	{
		foreach($this->depends_ as $depend)
			$depend->validate($form,$this);
	}
}

/**
@brief Message 饹
@note exFrame  <message> ˤ type ȤĥƤޤ
	  ǥեȤǤ type="const" ǤꡢåǤ뤳Ȥ򼨤ޤ
	  type="direct" ǥͤäľܥ顼åѤ뤳ȤǤޤ
	  ݲȤǤϿ侩ޤ
*/
class exDynaFieldMessage
{
	var $name_;			///< å̾
	var $key_;				///< å
	var $type_="const";	///< å

	function exDynaFieldMessage($name,$key,$type="const")
	{
		$this->name_=$name;
		$this->key_=$key;
		$this->type_=$type;
	}
	
	function to_string()
	{
		$ret ="";
		return (exFrame::MessageCatalog($this->key_));
	}
}

/**
@brief Depend ݲ饹
@deprecated
*/
class exDynaFieldDependProperty
{
	var $name_;	///< depend ̾
	
	/**
	@brief Υ饹Υ롼˴Ť¹Ԥ
	@see exDynaActionFormFieldProperty::validate()
	@param $form exDynaActionForm
	@param $field exDynaActionFormFieldProperty  exDynaFieldDependProperty Υ븵Υ󥹥
	@note $form λĥեץѥƥȤ˸Ԥä塢꤬ $form->addError 𤹤
	*/
	function validate(&$form,&$field)
	{
	}
	
	/**
	@brief name_ ץѥƥ򸵤˥顼å key ̤ƥ顼 form ɲä뤿Υإ
	@param $form exDynaActionForm
	@param $field exDynaActionFormFieldProperty  exDynaFieldDependProperty Υ븵Υ󥹥
	*/
	function addMessage(&$form,&$field)
	{
		$message = $field->getMsg($this->name_);
		$form->addError($message->to_string());
	}
}

/**
@brief ɬϥ롼򤢤魯饹
*/
class exDynaFieldDependRequired extends exDynaFieldDependProperty
{
	var $name_="required";
	
	function validate(&$form,&$field)
	{
		if(!$form->getVar($field->property_)) {
			$this->addMessage($form,$field);
		}
	}
}

/**
@brief κǾʸ¥롼򤢤魯饹
@remark Υ롼ϡϤʤƯޤ
*/
class exDynaFieldDependMinlength extends exDynaFieldDependProperty
{
	var $name_="minlength";

	function validate(&$form,&$field)
	{
		if($form->getVar($field->property_)) {
			if(!$form->validateMinLength($form->getVar($field->property_),$field->getVar('minlength')))
				$this->addMessage($form,$field);
		}
	}
}

/**
@brief κʸ¥롼򤢤魯饹
*/
class exDynaFieldDependMaxlength extends exDynaFieldDependProperty
{
	var $name_="maxlength";

	function validate(&$form,&$field)
	{
		if(!$form->validateMaxLength($form->getVar($field->property_),$field->getVar('maxlength')))
			$this->addMessage($form,$field);
	}
}

/**
@brief ϰ¥롼򤢤魯饹
*/
class exDynaFieldDependIntrange extends exDynaFieldDependProperty
{
	var $name_="intRange";

	function validate(&$form,&$field)
	{
		if(!$form->validateInRange($form->getVar($field->property_),$field->getVar('min'),$field->getVar('max')))
			$this->addMessage($form,$field);
	}
}

/**
@brief եγĥҥۥ磻ȥե륿롼򤢤魯饹
*/
class exDynaFieldDependExtension extends exDynaFieldDependProperty
{
	var $name_="extension";

	function validate(&$form,&$field)
	{
		$extensions = $field->getVar('extension');
		if(!is_array($extensions))
			$extensions = explode(",",$extensions);

		if(!$form->validateExtension($form->getVar($field->property_),$extension))
			$this->addMessage($form,$field);
	}
}

/**
@brief եκ祵롼򤢤魯饹
*/
class exDynaFieldDependMaxfilesize extends exDynaFieldDependProperty
{
	var $name_="maxfilesize";

	function validate(&$form,&$field)
	{
		if(!$form->validateMaxFilesize($form->getVar($field->property_),$field->getVar('maxFilesize')))
			$this->addMessage($form,$field);
	}
}

/**
@brief ͤͤɤå롼
@todo åѥ롩
*/
class exDynaFieldDependMask extends exDynaFieldDependProperty
{
	var $name_="mask";

	function validate(&$form,&$field)
	{
		$mask = $field->getVar('mask');
		$mask = str_replace("/","\\/",$mask);

		$pattern = "/".$mask."/";

		if(!preg_match($pattern,$form->getVar($field->property_)))
			$this->addMessage($form,$field);
	}
}

/**
@brief requireif ʰ
@remark ̤б
*/
class exDynaFieldDependRequiredif extends exDynaFieldDependProperty
{
	var $name_="requiredif";
	
	function validate(&$form,&$field)
	{
		$fieldJoin = ($join=$field->getVar('fieldJoin')) ? strtoupper($join) : "AND";
		
		if($fieldJoin!="AND")
			$result_flag = false;
		else
			$result_flag = true;

		for($i=0;$field->getVar('field['.$i.']');$i++) {
			$fieldName = $field->getVar('field['.$i.']');
			$fieldTest = $field->getVar('fieldTest['.$i.']');
			$fieldValue = $field->getVar('fieldValue['.$i.']');
		
			$flag = false;	
    		switch($fieldTest) {
    			case 'NULL':
    				$flag = !$form->getVar($fieldName);
    				break;

    			case 'NOTNULL':
    				$flag = $form->getVar($fieldName);
    				break;

    			case 'EQUAL':
    				$flag = ($form->getVar($fieldName)==$fieldValue);
    				break;
    		}

    		if($fieldJoin=="AND")
    			$result_flag&=$flag;
    		else
    			$result_flag|=$flag;
		}

		// Ƥʤ required å
		if($result_flag && !$form->getVar($field->property_))
			$this->addMessage($form,$field);
	}
}

/**
@brief ͤͤɤå롼
@todo åѥ롩
*/
class exDynaFieldDependEmail extends exDynaFieldDependProperty
{
	var $name_="email";

	function validate(&$form,&$field)
	{
		if(!$form->validateEmailAddress($form->getVar($field->property_)))
			$this->addMessage($form,$field);
	}
}

?>