<?php
/**
@brief XML ɡϤ뤿δʰ class
@version $Id: XMLLoader.php,v 1.7 2005/08/10 04:07:31 minahito Exp $
*/

/**
@brief XML ɡϤ뤿
δʰŪ class
*/
class AbstractXMLLoader {
	var $parser_;
	var $msg_;
	var $tag_;	///< ߥ

	function AbstractXMLLoader() {
		$this->msg_=array();
	}

	/**
	@brief 
	*/
	function load($file,$charset='iso-8859-1') {
		if(!file_exists($file)) {
			$this->msg_[]="File does not exist";
			return false;
		}
		$this->parser_ = xml_parser_create($charset);

		xml_set_object($this->parser_,$this);
		xml_parser_set_option($this->parser_,XML_OPTION_CASE_FOLDING,0);
		xml_set_element_handler($this->parser_,"startElement","endElement");
		xml_set_character_data_handler($this->parser_,"characterData");

		$fp=fopen($file,"r");
		if(!$fp) {
			$this->msg_[]="Can't open file";
			return false;
		}	
		
		while($data=fread($fp,4096)) {
			if(!xml_parse($this->parser_,$data,feof($fp))) {
				$err_string = xml_error_string(xml_get_error_code($this->parser_));
				$line = xml_get_current_line_number($this->parser_);
			}
		}
		
		xml_parser_free($this->parser_);
		
		fclose($fp);

        return true;
	}

	function startElement($parser,$name,$attrs=null) {
		$this->tag_=$name;

		$method=strtolower($name)."OpenTagHandler";
		$method=str_replace("-","_",$method);
		
		if(method_exists($this,$method)) {
			$this->$method($attrs);
		}
		else {
    		// Typo ֤ؤн
    		$method=strtolower($name)."OepnTagHandler";
    		$method=str_replace("-","_",$method);
    		if(method_exists($this,$method))
    			$this->$method($attrs);
		}
	}

	function endElement($parser,$name,$attrs=null) {
		$method=strtolower($name)."CloseTagHandler";
		$method=str_replace("-","_",$method);
		if(method_exists($this,$method))
			$this->$method($attrs);
	}
	
	function characterData($parser,$val)
	{
	}
	
	function isError()
	{
		return count($this->msg_) ? true : false;
	}
}

?>
