<?php
/**
@file
@brief DynaActionForm 򤦤ޤѤ뤿˳ĥ줿Ƽ說饹ե
@author minahito
@version $Id$

\section copyright Copyright and license
 Copyright (c) 2003-2004, minahito
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

1 Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer.

2 Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

3 Neither the name of the nor the names of its contributors may be used to 
  endorse or promote products derived from this software without specific 
  prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 SUCH DAMAGE.
*/

require_once "mojaLE/Controller/controller.class.php";
require_once "exForm/DynaActionForm.class.php";

/**
@brief SimpleFrontController  DynaActionForm 뤿Υ᥽åɤĥȥ饯饹
*/
class DynaFrontController extends SimpleFrontController
{
	function &getDynaActionForm($name)
	{
		$builder = new exAutoloadDAFBuilderXML($this->getModuleDir()."/forms");

		$builder->load($name);
		return $builder->getActionForm();
	}

	function &getDynaXoopsForm($name)
	{
		$builder = new exAutoloadDXFBuilderXML($this->request_,$this->getModuleDir()."/forms");

		$builder->load($name);
		return $builder->getXoopsForm();
	}
}

/**
@brief ȥɤб DynaActionForm ӥ

	   \par 
	   Υ饹 exDynaActionFormBuilderXML ΰ㤤ϡ᤯Ƽե򻲾ȤǤ褦
	   Υեֵ§˴ŤƼưŪɬפʥեץɤǤ
	   Τˤϥ󥹥ȥ饯ˡǥ쥯ȥѥ $formdir 򤢤ޤ
	   load ᥽åɤϡ <$formdir>/.xml/<$name>.xml եõƥɤߤޤ
	   Ʊ˥֥ȥΥץˡ name ȤǻꤵƤ륯饹줿ե
	   <$formdir>/<name>.class.php ˵ޤ

		\par XML ե̤ξˤޤȤƤ
		軰 $xmlbase_dir ͿС XML եõȤޤ
	    $xmlbase_dir ꤷϡľ򸡺ޤ
*/
class exAutoloadDAFBuilderXML extends exDynaActionFormBuilderXML
{
	var $formdir_=null;	/**< ȥɤδȤʤǥ쥯ȥѥǼץѥƥ */
	var $xmlbase_dir_ =null;	/**< XMLΥ١ǥ쥯ȥѥӻꤹΥǥ쥯ȥѥǼץѥƥ */

	function exAutoloadDAFBuilderXML($formdir=null,$xmlbase_dir=null)
	{
		parent::exDynaActionFormBuilderXML();
		$this->formdir_=$formdir;
		$this->xmlbase_dir_=$xmlbase_dir;
	}

	/**
	@brief ե̾ǤϤʤ륯饹̾⤷ XML ̾򸵤˥ե̾ꡢɤޤ
	*/
	function load($name)
	{
		$filename = null;
		if($this->xmlbase_dir_) {
			$filename = $this->xmlbase_dir_."/".$name.".xml";
		}
		elseif($this->formdir_) {
			$filename = $this->formdir_."/.xml/".$name.".xml";
		}
		else
			$filename = $name;

//		print "XML Τ $filename ɤ߹⤦ȤƤ<br/>\n";

		parent::load($filename);
	}

	/**
	@brief <form-bean>β
	@note ꤫
	*/
	function form_beanOpenTagHandler($arr)
	{
		$this->name_ = $arr['name'];
		$this->type_ = $arr['type'];

		if(!class_exists($this->name_)) {
			$filename = $this->formdir_."/".$this->name_ . ".class.php";
			if(file_exists($filename))
				require_once $filename;
		}
		
		parent::form_beanOpenTagHandler($arr);
	}
}

/**
@brief ȥɤб DynaActionForm ӥ

	   \par 
	   Υ饹 exDynaXoopsFormBuilderXML ΰ㤤ϡ᤯Ƽե򻲾ȤǤ褦
	   Υեֵ§˴ŤƼưŪɬפʥեץɤǤ
	   Τˤϥ󥹥ȥ饯ˡǥ쥯ȥѥ $formdir 򤢤ޤ
	   load ᥽åɤϡ <$formdir>/.xml/<$name>.xml եõƥɤߤޤ
	   Ʊ<xoopsform>Υץˡ class ȤǻꤵƤ륯饹줿
	   PHPץե<$formdir>/<class>.class.php ˵ޤ

		\par XML ե̤ξˤޤȤƤ
		軰 $xmlbase_dir ͿС XML եõȤޤ
	    $xmlbase_dir ꤷϡľ򸡺ޤ
*/
class exAutoloadDXFBuilderXML extends exDynaXoopsFormBuilderXML
{
	var $p_request_=null;	/**< ꥯȥ饹ؤΥݥ */

	var $formdir_=null;	/**< ȥɤδȤʤǥ쥯ȥѥǼץѥƥ */
	var $xmlbase_dir_ =null;	/**< XMLΥ١ǥ쥯ȥѥӻꤹΥǥ쥯ȥѥǼץѥƥ */

	function exAutoloadDXFBuilderXML(&$request,$formdir=null,$xmlbase_dir=null)
	{
		$this->p_request_=$request;
		$this->formdir_=$formdir;
		$this->xmlbase_dir_=$xmlbase_dir;

		parent::exDynaXoopsFormBuilderXML($this->p_request_->getAttribute('editform'));
	}

	/**
	@brief ե̾ǤϤʤ륯饹̾⤷ XML ̾򸵤˥ե̾ꡢɤޤ
	@todo ɥ󤬵ˤʤ뵤ˤʤ뵤ˤʤ
	*/
	function load($name)
	{
		$filename = null;
		if($this->xmlbase_dir_) {
			$filename = $this->xmlbase_dir_."/".$name.".xml";
		}
		elseif($this->formdir_) {
			$filename = $this->formdir_."/.xml/".$name.".xml";
		}
		else
			$filename = $name;

		parent::load($filename);
	}

	/**
	@brief <xoopsform>β
	@note ꤫
	*/
	function xoopsformOpenTagHandler($arr)
	{
		$classname = $arr['class'];

		if(!class_exists($classname)) {
			$filename = $this->formdir_ . "/" . $classname . ".class.php";
			if(file_exists($filename))
				require_once $filename;
		}
		
		parent::xoopsformOpenTagHandler($arr);
	}
}

?>