<?php
/**
@file
@brief XoopsForm ưŪ˺ӥե
@todo ȥȥ쥤ۤǤ褦ˤ
*/

require_once "include/XMLLoader.php";
require_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";

/**
@brief XoopsForm ưŪ˺ӥ
@todo using ɲ
*/
class exDynaXoopsFormBuilderXML extends AbstractXMLLoader
{
	var $master_;	/**< ΥӥǡθȤޥ */
	var $form_;	/**< Υӥž夲Ƥ XoopsForm Υ󥹥 */

	var $p_active_tray_=null;	/**< ȥ쥤ؤλ */
	var $p_active_element_;	/**< Υӥѡ˺Ƥ륨ȥӥؤλ */

	function exDynaXoopsFormBuilderXML(&$master)
	{
		parent::AbstractXMLLoader();
		$this->master_ = $master;
	}
	
	/**
	@brief ۤä XoopsForm ᤹
	@return XoopsForm
	*/
	function &getXoopsForm()
	{
		return $this->form_;
	}

	function xoopsformOpenTagHandler($arr)
	{
		$classname = $arr['class'];

		if(!class_exists($classname))
			die( $classname . " is not exists." ); 

		$this->form_ = new $classname(exFrame::MessageCatalog($arr['title']),$arr['name'],isset($arr['action']) ? $arr['action'] : "" );
	}

	function elementOpenTagHandler($arr)
	{
		if(isset($arr['type'])){
			$classname = "exDynaXoops".$arr['type']."ElementBuilder";
			if(!class_exists($classname))
				die( $classname . " is not exists." ); 

			$this->p_active_element_ = new $classname();
			$this->p_active_element_->setName($arr['name']);
		}
		else {
			// addXXXXElement Υ᥽åɥХåǽĴ٤
			$method_name = "add".ucfirst($arr['name'])."Element";
			if(method_exists($this->form_,$method_name))
				$this->form_->$method_name($this->form_,$this->master_);
		}
	}

	function elementCloseTagHandler($arr)
	{
		if(isset($this->p_active_element_)) {
    		$form=$this->p_active_element_->build();
    
    		// setupOption Υ᥽åɥХåǽĴ٤
    		$method_name = "setup".ucfirst($this->p_active_element_->getName())."Options";
    		if(method_exists($this->form_,$method_name))
    			$this->form_->$method_name($form);
    
    		// ӥ夫
    		unset($this->p_active_element_);

			if(isset($this->p_active_tray_) && $this->p_active_tray_) {
				$this->p_active_tray_->addElement($form);
			}
			else {
				$this->form_->addElement($form);
			}
		}
	}

	function trayOpenTagHandler($arr)
	{
		if(isset($arr['type'])) {
			$classname = "exDynaXoops".$arr['type']."TrayBuilder";

			if(!class_exists($classname))
				die( $classname . " is not exists." ); 

			$this->p_active_tray_ = new $classname();
			$this->p_active_tray_->setName($arr['name']);
		}
		// ----- FIXME -----
	}
	
	function trayCloseTagHandler()
	{
		if(isset($this->p_active_tray_)) {
			$form=$this->p_active_tray_->build();
			unset($this->p_active_tray_);
			
			$this->form_->addElement($form);
		}
	}
	
	function captionDataHandler($val)
	{
		if(isset($this->p_active_element_) && $this->p_active_element_)
			$this->p_active_element_->setCaption(exFrame::MessageCatalog($val));
		elseif($this->p_active_tray_)
			$this->p_active_tray_->setCaption(exFrame::MessageCatalog($val));
	}

	function attributeOpenTagHandler($arr)
	{
		$this->p_active_element_->setAttribute($arr['name'],$arr['value']);
	}
	
	function optionOpenTagHandler($arr)
	{
		$this->p_active_element_->addOption($arr);
	}

	function valueDataHandler($val)
	{
		if(preg_match("/master\.(\w+)$/",$val,$match)) {
			$this->p_active_element_->setValue($this->master_->getVar($match[1]));
		}
		else {
			$this->p_active_element_->setValue(exFrame::MessageCatalog($val));
		}
	}

	/**
	@brief Υǡ륳Хåؿ
	*/
	function characterData(&$parser,$val)
	{
		$val = trim($val);
		$method_name = $this->tag_."DataHandler";
		if($val && method_exists($this,$method_name))
			$this->$method_name($val);
	}
}

/**
@brief XoopsFormElement μǹۤ뤿ݥ饹
*/
class exDynaXoopsElementBuilder
{
	var $caption_;	/**< XoopsFormElement Υץ˻Ѥץѥƥ */
	var $name_;	/**< XoopsFormElement  name ˻Ѥץѥƥ */
	var $value_;	/**< XoopsFormElement Υǥեͤ˻Ѥץѥƥ */
	var $attributes_=array();	/**< ¾ץݻ뤿Ϣ */

	/**
	@brief ץꤹ
	@param $caption string
	*/
	function setCaption($caption)
	{
		$this->caption_=$caption;
	}
	
	/**
	@brief ץ
	@return string
	*/
	function getCaption()
	{
		return $this->caption_;
	}

	/**
	@brief name ꤹ
	@param $name string
	*/
	function setName($name)
	{
		$this->name_=$name;
	}

	/**
	@brief name 
	@return string
	*/
	function getName()
	{
		return $this->name_;
	}
	
	/**
	@brief (valueץѥƥ)򥻥åȤ
	@param $val var
	*/
	function setValue($val)
	{
		$this->value_=$val;
	}
	
	/**
	@brief (valueץѥƥ)᤹
	@return var
	*/
	function getValue()
	{
		return $this->value_;
	}

	/**
	@brief ץͤϿϥåޥåפΥץѥƥ $key  $val Ͽ 
	@param $key string
	@param $val var
	*/
	function setAttribute($key,$val)
	{
		$this->attributes_[$key]=$val;
	}

	/**
	@brief ץͤϿϥåޥåפΥץѥƥ $key ᤹ͤ
	@return var ͤϿƤʤ null
	*/
	function getAttribute($key)
	{
		return isset($this->attributes_[$key]) ? $this->attributes_[$key] : null;
	}

	/**
	@brief  $key ͤץϿƤ뤫ɤ᤹
	@return bool
	*/
	function isAttribute($key)
	{
		return isset($this->attributes_[$key]);
	}

	/**
	@brief ץ󥿥νԤϢޤ
	@param $arr Array
	*/
	function addOption(&$arr)
	{
	}

	/**
	@brief ۤ¹Ԥ XoopsFormElement ޤ
	@return XoopsFormElement Υ󥹥
	*/
	function &build()
	{
	}
}

/**
@biref XoopsFormText Ȥۤ륯饹
*/
class exDynaXoopsTextElementBuilder extends exDynaXoopsElementBuilder
{
	var $default_size_ = 32;
	var $default_maxlength_ = 128;

	function exDynaXoopsTextElementBuilder()
	{
		$this->setAttribute("size",$this->default_size_);
		$this->setAttribute("maxlength",$this->default_maxlength_);
	}

	function &build()
	{
		$ret = new XoopsFormText($this->getCaption(),$this->getName(),$this->getAttribute('size'),$this->getAttribute('maxlength'),$this->getValue());
		return $ret;
	}
}

/**
@biref XoopsFormTextArea Ȥۤ륯饹
@note ȥӥ塼ȤȤ rows  cols ޤ
*/
class exDynaXoopsTextAreaElementBuilder extends exDynaXoopsElementBuilder
{
	var $default_rows_ = 5;
	var $default_cols_ = 50;

	function exDynaXoopsTextAreaElementBuilder()
	{
		$this->setAttribute("rows",$this->default_rows_);
		$this->setAttribute("cols",$this->default_cols_);
	}

	function &build()
	{
		$ret = new XoopsFormTextArea($this->getCaption(),$this->getName(),$this->getValue(),
						$this->getAttribute('rows'), $this->getAttribute('cols'));
		return $ret;
	}
}

/**
@biref XoopsFormDHtmlTextArea Ȥۤ륯饹
@note ȥӥ塼ȤϸǤ exDynaXoopsTextAreaElementBuilder ƱǤ
@see exDynaXoopsTextAreaElementBuilder
*/
class exDynaXoopsDHtmlTextAreaElementBuilder extends exDynaXoopsTextAreaElementBuilder
{
	function &build()
	{
		$ret = new XoopsFormDHtmlTextArea($this->getCaption(),$this->getName(),$this->getValue(),
						$this->getAttribute('rows'), $this->getAttribute('cols'));
		return $ret;
	}
}

/**
@biref XoopsFormHidden Ȥۤ륯饹
*/
class exDynaXoopsHiddenElementBuilder extends exDynaXoopsElementBuilder
{
	function &build()
	{
		$ret = new XoopsFormHidden($this->getName(),$this->getValue());
		return $ret;
	}
}

/**
@biref XoopsFormRadio Ȥۤ륯饹
@note Υӥ addOption 󥿡եƤޤ
*/
class exDynaXoopsRadioElementBuilder extends exDynaXoopsElementBuilder
{
	var $options_=array();

	function exDynaXoopsSelectElementBuilder()
	{
		$this->options_=array();
	}

	function addOption(&$arr)
	{
		$this->options_[$arr['name']] = exFrame::MessageCatalog($arr['value']);
	}

	function &build()
	{
		$ret = new XoopsFormRadio($this->getCaption(),$this->getName(),$this->getValue());
		foreach($this->options_ as $key=>$val)
			$ret->addOption($key,$val);
		return $ret;
	}
}

/**
@biref XoopsFormCheckbox Ȥۤ륯饹
*/
class exDynaXoopsCheckboxElementBuilder extends exDynaXoopsRadioElementBuilder
{
	function &build()
	{
		$ret = new XoopsFormCheckBox($this->getCaption(),$this->getName(),$this->getValue());
		foreach($this->options_ as $key=>$val)
			$ret->addOption($key,$val);
		return $ret;
	}
}

/**
@biref XoopsFormSelect Ȥۤ륯饹
@note Υӥ addOption 󥿡եƤޤ
*/
class exDynaXoopsSelectElementBuilder extends exDynaXoopsRadioElementBuilder
{
	function &build()
	{
		$ret = new XoopsFormSelect($this->getCaption(),$this->getName(),$this->getValue());
		foreach($this->options_ as $key=>$val)
			$ret->addOption($key,$val);
		return $ret;
	}
	
}

/**
@biref XoopsFormTextDateSelect Ȥۤ륯饹
@note ȥӥ塼ȤȤ size ޤ
*/
class exDynaXoopsTextDateSelectElementBuilder extends exDynaXoopsElementBuilder
{
	var $default_size_=15;	/**< 󥹥ȥ饯 size °ȤϿǥե */
	
	function exDynaXoopsTextDateSelectElementBuilder()
	{
		$this->setAttribute('size',$this->default_size_);
	}

	function &build()
	{
		$ret = new XoopsFormTextDateSelect($this->getCaption(),$this->getName(),$this->getAttribute('size'),$this->getValue());
		return $ret;
	}
}

/**
@biref ܥۤ륯饹
*/
class exDynaXoopsSubmitElementBuilder extends exDynaXoopsElementBuilder
{
	function &build()
	{
		$ret = new XoopsFormButton($this->getCaption(),$this->getName(),$this->getValue(),'submit');
		return $ret;
	}
}

/**
@biref ꥻåȥܥۤ륯饹
*/
class exDynaXoopsResetElementBuilder extends exDynaXoopsElementBuilder
{
	function &build()
	{
		$ret = new XoopsFormButton($this->getCaption(),$this->getName(),$this->getValue(),'reset');
		return $ret;
	}
}

/**
@brief ٥ۤ륯饹
*/
class exDynaXoopsLabelElementBuilder extends exDynaXoopsElementBuilder
{
	function &build()
	{
		$ret = new XoopsFormLabel($this->getCaption(),$this->getValue());
		return $ret;
	}
}

class exDynaXoopsTrayBuilder extends exDynaXoopsElementBuilder
{
	var $elements_=array();
	var $demiliter_=null;
	
	function addElement(&$element)
	{
		$this->elements_[]=$element;
	}

	function &build()
	{
		$ret = new XoopsFormElementTray($this->getCaption(),$this->demiliter_,$this->getValue());
		foreach($this->elements_ as $ele){
			$ret->addElement($ele);
			unset($ele);
		}
		return $ret;
	}
}

/**
@brief ȥ쥤ۤ륯饹
*/
class exDynaXoopsHorizontallyTrayBuilder extends exDynaXoopsTrayBuilder
{
	var $demiliter_="<br/>";
}

/**
@brief ȥ쥤ۤ륯饹
*/
class exDynaXoopsVerticallyTrayBuilder extends exDynaXoopsTrayBuilder
{
	var $demiliter_="&nbsp;";
}

?>