<?php
include_once XOOPS_ROOT_PATH.'/modules/addbook/include/addbook_util.php' ;

class default_Item_listView_input extends mojaLE_AbstractView
{
	function &execute (&$controller, &$request, &$user)
	{
		global $xoopsModuleConfig ;
		
        $component=&$request->getAttribute('component');

//var_dump(get_class($request));
//var_dump($component->table_model_->_column_);

		$total_items = $component->table_model_->listController_->total_ ; 
		$renderer = new mojaLE_SmartyRenderer($controller,$request,$user);
		
		// ǡɽפ
		$rowdata = $component->table_model_->_row_data_ ;
		// formopitons򥻥쥯ȥ֤
		for($i=0; $i<count($rowdata); $i++){
			$form_options_array = AddbookUtil::Str2FormOptionsArray($rowdata[$i]['formoptions']);
			if( count($form_options_array) == 0 ){
				 continue ;
			}else{
				$options = '';
				foreach($form_options_array as $value=>$label){
					$options .= sprintf('<option value="%s">%s</option>', $value, $label) ;
				}
				$options = sprintf('<select>%s</select>', $options) ;
				$rowdata[$i]['formoptions'] = $options ;
			}
		}
		
		$renderer->setTemplate('addbook_admin_item_list.tpl');
        $renderer->setAttribute('rowdata',$rowdata); 
        $renderer->setAttribute('tablecolumn',$this->_change_field2name($component->table_model_->_column_)); 
        $renderer->setAttribute('total_items',$total_items); 
		// navi
 		include_once( XOOPS_ROOT_PATH.'/class/pagenav.php' ) ;
		$perpage = 20 ;
		$current_start = $request->getParams('start') ;
		$sort = $request->getParams('sort');
		$nav = new XoopsPageNav( $total_items , $perpage , $current_start , 'start' , "action=item_list&amp;sort=$sort&amp;perpage=$perpage" ) ;
	        $renderer->setAttribute('page_navi',$nav->renderNav(4)); 
		$renderer->setAttribute('sort',$sort);
//       $renderer->setAttribute('component',$component->fetchHtml()); 
		// Τۤ˥餹
		$tblnm = array('a'=>$xoopsModuleConfig['tableA_name'], 'b'=>$xoopsModuleConfig['tableB_name']) ;
		$renderer->setAttribute('tablename', $tblnm);
		$checked = array('tbl_a'=> ($request->getParams('tbl_a')) ? 'checked' : '' , 
						  'tbl_b'=> ($request->getParams('tbl_b')) ? 'checked' : '' );
		$renderer->setAttribute('checked', $checked);
		
        return $renderer;
	}

	// ե̾ˤ
	function _change_field2name($field_name){
		foreach($field_name as $key=>$value){
			switch(strtoupper($value)){
				case 'ITEMID':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_ITEMID_NAME ;
				break ;
				case 'ITEMNAME':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_ITEMNAME_NAME ;
				break ;
				case 'ITEMDESC':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_ITEMDESC_NAME ;
				break ;
				case 'FORMTYPE':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_FORMTYPE_NAME ;
				break ;
				case 'FORMMAX':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_FORMMAX_NAME ;
				break ;
				case 'FORMLENGTH':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_FORMLENGTH_NAME ;
				break ;
				case 'FORMDEFAULT':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_FORMDEFAULT_NAME ;
				break ;
				case 'FORMOPTIONS':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_FORMOPTIONS_NAME ;
				break ;
				case 'TABLENAME':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_TABLENAME_NAME ;
				break ;
				case 'WEIGHT':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_WEIGHT_NAME ;
				break ;
				case 'VISIBLE_L':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_VISIBLE_L_NAME ;
				break ;
				case 'VISIBLE_E':
					$field_name[$key] = _MD_A_ADDBOOK_LANG_VISIBLE_E_NAME ;
				break ;
			}
		}
		return $field_name ;
	}
}

?>
