<?php

require_once "xoops/object.php";

class addbookValueObject extends exXoopsObject {
	function addbookValueObject($id=null)
	{
		$this->initVar('gid', XOBJ_DTYPE_INT, 0, true);
		$this->initVar('vitemid', XOBJ_DTYPE_INT, 0, true);
		$this->initVar('value', XOBJ_DTYPE_TXTAREA, null, false, null);
		$this->initVar('submittime', XOBJ_DTYPE_INT, 0, false);
		$this->initVar('submitter', XOBJ_DTYPE_INT, 0, false);

		if ( is_array ( $id ) )
			$this->assignVars ( $id );
	}

	/// Database Connect Model
	function &getTableInfo()
	{
		$tinfo = new exTableInfomation('addbook_value',array('gid','vitemid'));
		return ($tinfo);
	}
	
	// actionclass$bridgeȤƻȤѤitemѤΤä
	function deleteItems(){
		$deleted_item = array();
		$addbookValueObject_prop = array('gid','vitemid','value','submittime','submitter');
		foreach($this->vars as $key=>$value){
			if(!in_array($key , $addbookValueObject_prop)){
				unset($this->vars[$key]) ;
				$deleted_item[] = $key ;	
			}
		}
		return $deleted_item ;
	}
	
	// getVararrayкѤ
	function getVar($name, $option='s'){
		global $xoopsModuleConfig ;
		$value = parent::getVar($name, $option);
		$value_array = @unserialize($value);
		if(is_array($value_array)){
			$value = implode($xoopsModuleConfig['data_implode_str'], $value_array);
		}else{
			$value = htmlspecialchars($value);	
		}
		return $value ;
	}
}

class addbookValueObjectHandler extends exXoopsObjectHandler {
	// constructor
	function addbookValueObjectHandler(){
		global $xoopsDB ;
		$class = 'addbookValueObject' ;
		$this->exXoopsObjectHandler($xoopsDB,$class) ;
	}
	
	// gidκͤ
	function getMaxGid($table_name='addbook_valueA'){
		$max_gid = 0 ;
		$query = sprintf('select max(gid) from %s', $this->db_->prefix($table_name)) ;
		$re = $this->db_->query($query);
		if($this->db_->getRowsNum($re) == 1){
			$result = $this->db_->fetchRow($re) ;
			$max_gid = $result[0] ;
		}
		return $max_gid ;
	}
	
	// valueA/valueBΤvitemidͤdistinctǼꡢˤ
	// @return array('aa','bb','cc',....)
	function getDistinctValue($table_name,$vitemid){
		$return_array = array();
		$v_criteria =& new Criteria('vitemid', $vitemid);
		$v_criteria->setGroupby('value');
		$v_criteria->setSort('value');
		$v_criteria->setOrder('ASC');
		$select_options = $this->getObjects($v_criteria);
		// ȤǼ
		foreach($select_options as $opt){
			$return_array[] = $opt->getVar('value','n');
		}
		return $return_array;
	}
	
	// gidǤ줿distinctgidηʻʤɤ˻ѡ
	function getRowNum($criteria){
		if(isset($criteria) && is_subclass_of($criteria,'criteriaelement')) {
			$tablename = implode(",",array_map(array($this->db_,'prefix'),$this->_tableinfo_->tablenames_)) ;
			$sql = sprintf('select count(*) as c from %s', $tablename );

			$sql .= ' '.$criteria->renderwhere().' ' ;
			if($criteria->groupby!=''){
				$sql .= ' '.$criteria->getGroupby().' ' ;	
			}
			$result=$this->db_->query($sql);
			if(!$result){ return 0 ; }
			$row=$this->db_->getRowsNum($result) ;
			return $row;
		}
		return 0 ;
	}
	
	// gidǻꤵ줿ǡ
	function deleteByitemid($criteria){
		if(isset($criteria) && is_subclass_of($criteria,'criteriaelement')) {
			$tablename = implode(",",array_map(array($this->db_,'prefix'),$this->_tableinfo_->tablenames_)) ;
			$sql = sprintf('delete from %s', $tablename );

			$sql .= ' '.$criteria->renderwhere().' ' ;
			$result=$this->db_->query($sql);
			if(!$result){ return false ; }
			$row=$this->db_->getAffectedRows($result) ;
			return $row;
		}
		return false ;
	}
}

?>