CREATE TABLE addbook_item ( 
	itemid mediumint(5) auto_increment,
	itemname varchar(255) not null,
	itemdesc text  not null,
	formtype varchar(255)  not null,
	formmax smallint(3)  not null default 255,
	formlength varchar(10)  not null default 30,
	formdefault varchar(255)  not null ,
	formoptions text  not null ,
	tablename char(1)  not null ,
	weight mediumint(5) not null default 0,
	visible_l tinyint(1)  not null default 1,
	visible_e tinyint(1)  not null default 1,
	PRIMARY KEY (itemid)
) TYPE=MyISAM;

CREATE TABLE addbook_valueA ( 
	gid int(8)  not null ,
	vitemid mediumint(5)  not null,
	value text  not null,
	submittime int(10)  not null,
	submitter mediumint(5)  not null,
	PRIMARY KEY (gid,vitemid)
) TYPE=MyISAM;

CREATE TABLE addbook_valueB ( 
	gid int(8)  not null,
	vitemid mediumint(5)  not null,
	value text  not null,
	submittime int(10)  not null,
	submitter mediumint(5)  not null,
	PRIMARY KEY (gid,vitemid)
) TYPE=MyISAM;

INSERT INTO addbook_item VALUES (1, 'nickname', '(SAMPLE) input your nickname', 'text', 255, '30', '', '', 'a', 1, 1, 1);
INSERT INTO addbook_item VALUES (2, 'address', '(SAMPLE) please input your address :-?', 'text', 255, '60', '', '', 'a', 2, 1, 1);
INSERT INTO addbook_item VALUES (3, 'company', '(SAMPLE) please input your company', 'text', 255, '30', '', '', 'b', 1, 1, 1);
INSERT INTO addbook_item VALUES (4, 'sex', '(SAMPLE) choice your gender', 'select', 255, '30', '', '<male><female>', 'a', 1, 1, 1);
INSERT INTO addbook_item VALUES (5, 'company address', '(SAMPLE) input company address', 'text', 255, '50', '', '', 'b', 2, 1, 1);
INSERT INTO addbook_item VALUES (6, 'OS', '(SAMPLE) choice what you use', 'checkbox', 255, '30', '', '<win95|Windows95><Macintosh|MacOS><Linux|Linux>', 'b', 3, 1, 1);
INSERT INTO addbook_item VALUES (7, 'FAX', '(SAMPLE) ', 'text', 255, '30', '', '', 'b', 6, 1, 1);

