<?php
/**
@file
@brief ե뤫ưŪ˺Ǥ륢ե륿饹Ƥե
@author minahito
@version $Id$

\section copyright Copyright and license
 Copyright (c) 2003-2004, minahito
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

1 Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer.

2 Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

3 Neither the name of the nor the names of its contributors may be used to 
  endorse or promote products derived from this software without specific 
  prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 SUCH DAMAGE.
*/

require_once "exForm/Filter.php";
require_once "exForm/DynaActionForm.php";
require_once "include/XMLLoader.php";

class exDynaActionFilter extends exAbstractFilterForm
{
	var $filter_properties_=array();	/**< ꥯ̾Ϣ */
	var $default_sort_=array();	/**< Ϣ */

	/**
	@brief ȥֹ $key ˥ȥץѥƥ̾ $name 򥻥åȤ
	@param $key int
	@param $name string
	*/
	function setSortProperty($key,$name)
	{
		$this->sort_[intval($key)] = $name;
	}

	/**
	@brief ȥֹ $key ꥽ȥץѥƥ᤹̾
	@note exDynaActionFilter ǤϡȥꤷƥȹܤϿ뤿ᡢ
	      ľź˻ѤƤ
	*/
	function getSortProperty($key)
	{
		return isset($this->sort_[intval($key)]) ? $this->sort_[intval($key)] : null;
	}

	function addDefaultSort($name,$order)
	{
		$this->default_sort_[] = array('name'=>$name, 'order'=>$order);
	}
}

class exDynaActionFilterBuilderXML extends AbstractXMLLoader
{
	var $name_=null;	///< Υե륿̾
	var $type_=null;	///< Υե륿Υסʡƥ饹⤷ϥ饹̾
	var $filter_=null;	///< Ƥ DynaActionFilter 󥹥

	function &getActionFilter()
	{
		return $this->filter_;
	}

	/**
	@brief ꤵ줿饹̾ǥ󥹥󥹤κߤơ᤹
	@internal
	@return object
	@todo exDynaActionFormBuilderXML::_createInstance ȥɥ򵯤Ƥ
	*/
	function &_createInstance($class_name)
	{
		$ret=null;

		if(class_exists($class_name))
			$ret = new $class_name();

		return $ret;		
	}

	/**
	@brief <filter-form>β
	@note ޤ name Ȥ̾Τǥ饹κߤޤä硢 type ȤΥ饹Ѥޤ
	*/
	function filter_formOpenTagHandler($arr)
	{
		// ꤫
	}

	/**
	@brief <sort-property>β
	*/
	function sort_propertyOpenTagHandler($arr)
	{
		$this->filter_->setSortProperty($arr['key'],$arr['name']);
	}
	
	/**
	@brief <default-sort>β
	*/
	function default_sortOpenTagHandler($arr)
	{
		$this->filter_->addDefaultSort($arr['name'],$arr['order']);
	}
}

?>