<?php
/**
@file
@brief ưŪեƤե
@author minahito
@version $Id$

\section copyright Copyright and license
 Copyright (c) 2003-2004, minahito
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

1 Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer.

2 Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

3 Neither the name of the nor the names of its contributors may be used to 
  endorse or promote products derived from this software without specific 
  prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 SUCH DAMAGE.
*/

require_once "exForm/DynaFormProperty.class.php";
require_once "exForm/DynaFieldProperty.class.php";

/** @name DynaActionForm Υեɥץѥƥפʰ̣ΤȤϤ뤬 */
//@{
define("EXDA_FTYPE_NULL","null");		///< null 򤷤ᤷޤ
define("EXDA_FTYPE_INT","int");		///< int 򤷤ᤷޤ
define("EXDA_FTYPE_INT_ARRAY","int");		///< int 󷿤򤷤ᤷޤ
define("EXDA_FTYPE_STRING","String");	///< string 򤷤ᤷޤ
define("EXDA_FTYPE_STRING_ARRAY","String");	///< string 󷿤򤷤ᤷޤ
define("EXDA_FTYPE_FILE","File");		///< FormFile ֥ȷ򤷤ᤷޤ
define("EXDA_FTYPE_OTHER","other");		///< ¾η򤷤ᤷޤ
//@}

require_once "exForm/Form.php";
require_once "include/XMLLoader.php";

/**
@brief ưŪ˹ۤ륢ե
*/
class exDynaActionForm extends exActionFormEx
{
	var $name_;	///< ե̾

	/**
	@brief եηʥ饹̾
	@note ιʳΰ̣Ϥޤ
	@attension get_class ǼݤμºݤΥ饹Ȥݾڤޤ
	*/
	var $type_;
	var $fieldProperties_;	///< Array(HashMap) եɥץѥƥΥ쥯
	var $formProperties_;

	/**
	@brief $key ǻꤵ줿եɥץѥƥͤޤ
	@note Υ᥽åɤϽ exAbstractActionForm ǵҤȤΡ
	       \code
	       $form->key_
	       \endcode
	       ޤĤޤꡢ
	       \code
	       $form->key_
	       $form->getVar('key')
	       \endcode
	       ϡμݤƱǤ
	       Υ᥽åɤϥץѥƥͤؤΥ򣱥ȥڸ뤿˺ޤ
	@return ΤȤ null ᤹
	*/
	function getVar($key)
	{
		return isset($this->formProperties_[$key]) ? $this->formProperties_[$key]->value_ : null;
	}
	
	/**
	@brief $key ǻꤵ줿եɥץѥƥͤǼޤ
	@see getVar()
	@note ˼ fetch ǻѤ
	@return ΤȤ false ᤹
	*/
	function setVar($key,&$value)
	{
		if(isset($this->formProperties_[$key])) {
			$this->formProperties_[$key]->value_=$value;
		}
		else {
			return false;
		}
	}
	
	/**
	@brief 顼åȤ٤ƤΥեץѥƥͤϢ˳Ǽᤷޤ
	@deprecated Υ᥽åɤ Xoops ƥץ졼Ȥ֥ȤޤǤηҤȤƤΤ
	              ѤƲ
	*/
	function &getArray()
	{
		$ret = array();
		foreach(array_keys($this->formProperties_) as $key)
			$ret[$key] = $this->getVar($key);

		if($this->isError())
			foreach($this->msg_ as $msg)
				$ret['err_msg'][] = $msg;

		return $ret;
	}

	/**
	@brief fetch ᥽å

	       \par ư롼
	       Ūˤ formProperties_ 쥯饪֥ȤҤȤĤļФ
           fetch ĤƤեץѥƥΥ֥ȤФ fetch ᥽åɤ򥳡뤹롣
	       ȼ fetch ᥽åɤƤϤ򥳡뤹

	       \par  fetch ᥽åɤ̿̾§
	       \code
	       fetch + ucfirst(strtolower(<ץѥƥ̾>))
	       \endcode

	@attention ˤ fetch ĤƤʤեץѥƥФ fetch ϹԤʤ
	            fetch ᥽åɤƤƤ⡢ϥ롼롣
	*/
	function fetch(&$master,&$request)
	{
		foreach(array_keys($this->formProperties_) as $key) {
			$property=&$this->formProperties_[$key];
			// print_r($property);
			if($property->fetch_) {
				$method = "fetch".ucfirst(strtolower($property->name_));
	    		if(method_exists($this,$method)) {
	    			$this->$method($master,$request);
	    		}
	    		else {
					$property->fetch($request);
	    		}
			}
		}
		
		$this->validate();
	}

	/**
	@brief fetch Ԥ
	@remark Υ᥽åɤ DynaActionForm Τ褦ʣư򤹤륢եˤ
	        Фȸʬ뤿˿ƥ饹Фɲäޤ
	@note  validate ᥽åɤФǥ뤵ޤ
          ܤ fetch() ᥽åɤ򻲹ͤΤȡ
	@attention fetch() θ˼ưǥ뤵ޤľܥåʤǲ
	*/
	function validate()
	{
		foreach(array_keys($this->formProperties_) as $key) {
			if(isset($this->fieldProperties_[$key]))
				$this->fieldProperties_[$key]->validate($this);

			// ȼ
			$method = "validate".ucfirst(strtolower($key));
    		if(method_exists($this,$method)) {
    			$this->$method();
    		}
		}
	}
	
	function load(&$master,&$request)
	{
		foreach(array_keys($this->formProperties_) as $key) {
			$property=&$this->formProperties_[$key];
			if($property->load_) {
				$property->value_=$master->getVar($property->name_,'e');
			}
		}
	}

	function update(&$master)
	{
		foreach(array_keys($this->formProperties_) as $key) {
			$property=&$this->formProperties_[$key];
			if($property->update_) {
				$master->setVar($property->name_,$property->value_);
			}
		}
	}
	
	/**
	@brief եץѥƥ $property 򥳥쥯 formProperties_ ץѥƥɲäޤ
	@param $property exDynaActionFormProperty
	*/
	function addFormProperty(&$property)
	{
		$this->formProperties_[$property->name_] = $property;
	}

	/**
	@brief եɥץѥƥ $field 򥳥쥯 fieldProperties_ ץѥƥɲäޤ
	*/
	function addFieldProperty(&$field)
	{
		$this->fieldProperties_[$field->property_] = $field;
	}
}

/**
@brief 󥿥åȤν񤷤 exDynaActionForm
*/
class exDynaTicketActionForm extends exDynaActionForm
{
	var $ticket_;

	function &getArray()
	{
		$ret=parent::getArray();
		if(is_object($this->ticket_)) {
			$ret['token_hidden']=$this->ticket_->makeHTMLhidden();
		}
		return $ret;
	}

	function init(&$master,&$request) {
		if($_SERVER['REQUEST_METHOD']=='POST') {
			$this->fetch($master,$request);
			if($this->isError()) {
				// åȤȯ
				$this->_createToken();
				return ACTIONFORM_INIT_FAIL;
			}
			else {
				// åȤ򥻥å󤫤äƤ
				exOnetimeTicket::unsetSession($this->getTicketName());
				return ACTIONFORM_POST_SUCCESS;
			}
		}
		else {
			$this->load($master,$request);
			$this->_createToken();
			return $this->isError() ? ACTIONFORM_INIT_FAIL : ACTIONFORM_INIT_SUCCESS;
		}
	}

	/**
	@brief 󥿥åȤ䤤碌ԤäƤ fetch
	@note Ѿ饹ǥС饤ɤݡɬ parent::fetch($master) Ƥ
	*/
	function fetch(&$master,&$request)
	{
		parent::fetch($master,$request);
		if(!exOnetimeTicket::inquiry($this->getTicketName())) {
			$this->addError($this->getTicketErrorMessage());
		}
	}

	/**
	@brief 󥿥åȥ饹֤ޤ
	*/
	function &getOnetimeTicket()
	{
		return $this->ticket_;
	}

	/**
	@brief 󥿥åȤȯ
	*/
	function _createToken()
	{
		$this->ticket_ = new exOnetimeTicket($this->getTicketName(),$this->getTicketLifetime(),EXFRAME_SALT);
		$this->ticket_->setSession();
	}

	/**
	@brief åȤǧ֤̾ޤ
	@note ɬפ˱ƷѾ饹ǥС饤ɤԤäƤ
	@return string
	*/
	function getTicketName()
	{
		return "_token_".$this->name_;
	}

	/**
	@brief åȤΥ饤ե֤ޤá
	@note ɬפ˱ƷѾ饹ǥС饤ɤԤäƤ
	@return int
	*/
	function getTicketLifetime()
	{
		// 60ʬ֤
		return 3600;
	}

	/**
	@brief åȥ顼Υ顼å֤ޤ
	@return string
	*/
	function getTicketErrorMessage()
	{
		return "TICKET ERROR";
	}
}

/**
@brief XML եɤ߹ߡ DynaActionForm 󥹥󥹤᤹
@remarks Υӥ饹ϥ󥹥󥹤 _createInstance ᥽åɤǺޤ
         Υ᥽åɤʸ󤫤饯饹̾ޤ
         륤󥹥󥹤Υ饹ϥϡɥɤƤʤΤǡ exDynaActionForm Υ֥饹
         ۲ǽǤ
\section Ȥ
\par ʻȤ
ޤΥ饹Υ󥹥󥹤ޤ
\code
 $builder = new exDynaActionFormBuilderXML();
\endcode
ˡ load ᥽åɤ XML եΥեѥϤޤ
\code
 $builder->load(<եѥ>);
\endcode
⤷顼ʤХեबƤޤgetActionForm Ǥ뤳ȤǤޤ
\code
 $editform=$builder->getActionForm();
\endcode

\par άŪʻȤ
  DynaFrontController ϡʾμ³񤷤ʥ᥽åɤäƤޤ
*/
class exDynaActionFormBuilderXML extends AbstractXMLLoader
{
	var $form_=null;	///< Ƥ DynaActionForm 󥹥
	var $p_active_property_;	///<  XML ץ󤷤Ƥʥե˥ץѥƥؤΥݥ
	var $p_active_field_;	///<  XML ץ󤷤ƤեɥץѥƥؤΥݥ

	var $active_var_name_ = null;	///<  XML ѡƤ <var>  <var-name> 
	var $active_var_value_ = null;	///<  XML ѡƤ <var>  <var-value> 

	function exDynaActionFormBuilderXML($processor=null)
	{
		parent::AbstractXMLLoader($processor);
	}

	/**
	@brief ե४֥Ȥᤷޤ
	@remark Υ᥽åɤ XML 饢ե˻Ѥ롣
            ǤʤС null λǤ롣
	*/
	function &getActionForm()
	{
		return $this->form_;
	}

	/**
	@brief <form-bean>β
	@note ޤ name Ȥ̾Τǥ饹κߤޤä硢 type ȤΥ饹Ѥޤ
	*/
	function form_beanOpenTagHandler($arr)
	{
		$this->name_ = $arr['name'];
		$this->type_ = $arr['type'];

		$this->form_ = $this->_createInstance($this->name_);
		if(!$this->form_) {
			$this->form_ = $this->_createInstance($this->type_);
			if(!is_object($this->form_))
				die($this->type_." is not exists.");	///< @todo die åΥå
		}
		
		$this->form_->name_ = $this->name_;
		$this->form_->type_ = $this->type_;
	}
	
	/**
	@brief ꤵ줿饹̾ǥ󥹥󥹤κߤơ᤹
	@internal
	@return object
	*/
	function &_createInstance($class_name)
	{
		$ret=null;

		if(class_exists($class_name))
			$ret = new $class_name();

		return $ret;		
	}
	
	/**
	@brief <form-propery>β
	*/
	function form_propertyOpenTagHandler($arr)
	{
		$this->p_active_property_ = exDynaActionFormPropertyFactory::create($arr['type']);
		if(!is_object($this->p_active_property_)) {
			die($arr['name']."'s type is not exist");	///< @todo die åΥå
		}
		$this->p_active_property_->name_=$arr['name'];
		$this->p_active_property_->type_=$arr['type'];
		
		if(isset($arr['fetch']) && ( $arr['fetch']=="false" || $arr['fetch']==0 ))
			$this->p_active_property_->fetch_=false;

		if(isset($arr['load']) && ( $arr['load']=="false" || $arr['load']==0 ))
			$this->p_active_property_->load_=false;

		if(isset($arr['update']) && ( $arr['update']=="false" || $arr['update']==0 ))
			$this->p_active_property_->update_=false;
	}
	
	function form_propertyCloseTagHandler()
	{
		$this->form_->addFormProperty($this->p_active_property_);
	}

	/**
	@brief <option>β
	@todo ϤҤɤΤǸǥХåڤؤ
	*/
	function optionOpenTagHandler($arr)
	{
		$name = strtolower($arr['name']);
		$value = isset($arr['value']) ? strtolower($arr['value']) : null;
		if($name=="fetch" && ($value=="false" || $value==0)) {
			$this->p_active_property_->fetch_=false;
		}
		elseif($name=="update" && ($value=="false" || $value===0)) {
			$this->p_active_property_->update_=false;
		}
		elseif($name=="load" && ($value=="false" || $value===0)) {
			$this->p_active_property_->load_=false;
		}
		elseif($name=="default") {
			$this->p_active_property_->value_=$arr['value'];	// strtolower 򤱤
		}
	}

	/**
	@brief <field>β
	*/
	function fieldOpenTagHandler($arr)
	{
		$this->p_active_property_ = new exDynaActionFormFieldProperty($arr['property']);

		foreach (explode(',',$arr['depends']) as $depend ) {
			if(!$this->p_active_property_->addDepend($depend)) {
				die( $depend." is not rule.");	///< @todo die åΥå
			}
		}

	}
	
	/**
	@brief <field>λν
	*/
	function fieldCloseTagHandler()
	{
		$this->form_->addFieldProperty($this->p_active_property_);
	}
	
	/**
	@brief <msg>β
	*/
	function msgOpenTagHandler($arr)
	{
		$this->p_active_property_->addMsg(new exDynaFieldMessage($arr['name'],$arr['key']));
	}
	
	/**
	@brief <var>β
	@remarks 硼ȵˡݾڤ뤿 name Ȥ value ȤС줾
	         <var-name> <var-value> ȤƽԤޤ
	*/
	function varOpenTagHandler($arr)
	{
		if(isset($arr['name']) && isset($arr['value'])) {
			$this->active_var_name_ =$arr['name'];
			$this->active_var_value_ = $arr['value'];
		}
	}

	function varCloseTagHandler()
	{
		$this->p_active_property_->addVar($this->active_var_name_,$this->active_var_value_);
	}

	function var_valueCloseTagHandler()
	{
		$this->p_active_property_->addVar($this->active_var_name_,$this->active_var_value_);
	}
	
	/**
	@brief Υǡ륳Хåؿ
	*/
	function characterData(&$parser,$val)
	{
		if(trim($val)) {
			switch($this->tag_) {
				case "var-name":
					$this->active_var_name_ = $val;
					break;

				case "var-value":
					$this->active_var_value_ = $val;
					break;
			}
		}
	}
}

?>