<?php
/**
@file
@brief CppTest ١ˤʤꥷץʥƥȥȤƤե
*/

require_once dirname(__FILE__)."/exTestOutput.class.php";

/**
@brief ƥñ̤ξ򼨤ȥ饯ȤƤΥ饹
*/
class exTEST_DATA
{
	var $m_methodName_;		///< ᥽å̾
	var $m_name_;				///< ƥ̾
	var $m_countSuccess_=0;	///< ƥȤ
	var $m_countError_=0;		///< ƥȤΥ顼

	var $m_assertments_;		///< ΥƥȤȯȤλȤޤ٥

	function exTEST_DATA($methodName,$name=null)
	{
		$this->m_methodName_=$methodName;
		if($name)
			$this->m_name_=$name;
		else
			$this->m_name_=$methodName;
	}

	function getName()
	{
		return $this->m_name_;
	}
	
	function addAssert(&$assert)
	{
		$this->m_assertments_[]=&$assert;
	}
	
	function getAsserts()
	{
		return $this->m_assertments_;
	}
}

/**
@brief ΥȾ򤷤᤹ȥ饯㡼ȤƤΥ饹
*/
class exASSERT_DATA
{
	var $m_testName_;
	var $m_suiteName_;
	var $m_file_;
	var $m_line_;
	var $m_message_;
	
	function exASSERT_DATA($testName,$suiteName,$file,$line,$message)
	{
		$this->m_testName_=$testName;
		$this->m_suiteName_=$suiteName;
		$this->m_file_=$file;
		$this->m_line_=$line;
		$this->m_message_=$message;
	}
}

/**
@brief CppTest ١ˤץʥƥȥȥ饹
*/
class exTestSuite
{
	var $m_suites_ = array();
	var $m_tests_ = array();	///< exTEST_DATA Υ󥹥󥹤¤٤Ϣ
	var $m_assertments_=array();
	var $m_output_=null;
	
	var $m_success_ = true;
	
	var $m_countError_=0;		///< 顼򵯤ƥȤΥ
	
	var $m_continueAfterFailuerFlag_=true;
	
	
	function exTestSuite()
	{
	}
	
	function getSuiteName()
	{
		return get_class($this);
	}
	
	function setup()
	{
	}
	
	function tear_down()
	{
	}

	/**
	@brief ƥȥȤɲä
	*/
	function add(&$suite)
	{
		$this->m_suites_[$suite->getSuiteName()]=&$suite;
	}
	
	/**
	@brief regster_test ᥽åɤΥꥢ
	*/
	function TEST_ADD($methodName,$testName=null)
	{
		$this->register_test($methodName,$testName);
	}
	
	/**
	@brief ƥȤϿ
	@return bool 
	@note Ʊ̾ΥƥȤϿƤϡϿϹԤޤ
	*/
	function register_test($methodName,$testName=null)
	{
		$test = new exTEST_DATA($methodName,$testName);
		if(!isset($this->m_tests_[$test->getName()])) {
			$this->m_tests_[$test->getName()] =& $test;
			return true;
		}

		return false;
	}

	function run(&$output,$cont_after_fail=true)
	{
		$this->m_continueAfterFailuerFlag_ = $cont_after_fail;

		if(!count($this->m_suites_))
			$this->add($this);

		$output->setSuite($this);

		foreach(array_keys($this->m_suites_) as $key) {
			exTestSuiteUtil::currentSuiteName($this->m_suites_[$key]->getSuiteName());
			$this->m_suites_[$key]->run_test();
		}
	}
	
	/**
	@brief ƥȥ¹Ԥ
	*/
	function run_test()
	{
		foreach($this->m_tests_ as $test) {
   			$this->setup();
   			$this->m_success_=true;

			$methodName=$test->m_methodName_;
			exTestSuiteUtil::currentTestName($test->m_name_);

			$this->$methodName();
			if(!$this->m_success_)
				$this->m_countError_++;

			$this->tear_down();
		}
	}
	
	function easy_run($cont_after_fail=true)
	{
		$output = new exTestOutputXoops();
		$this->run($output,$cont_after_fail);
		$output->generate();
		$output->display();
	}
	
	function TEST_FAIL($msg,$file=null,$line=null)
	{
		if($this->isContinueAfterFailure())
			$this->assertment($file,$line,$msg);
	}

	function TEST_ASSERT($expr,$file=null,$line=null)
	{
		if($this->isContinueAfterFailure())
			if(!$expr) {
				$this->assertment($file,$line);
			}
	}
	
	function TEST_ASSERT_MSG($expr,$msg,$file=null,$line=null)
	{
		if($this->isContinueAfterFailure())
			if(!$expr) {
				$this->assertment($file,$line,$msg);
			}
	}

	function TEST_ASSERT_DELTA($a,$b,$delta,$file=null,$line=null)
	{
		if($this->isContinueAfterFailure())
			if(($b < $a-$delta || $b > $a+$delta)) {
				$this->assertment($file,$line);
			}
	}

	function TEST_ASSERT_DELTA_MSG($a,$b,$delta,$msg,$file=null,$line=null)
	{
		if($this->isContinueAfterFailure())
			if(($b < $a-$delta || $b > $a+$delta)) {
				$this->assertment($file,$line,$msg);
			}
	}
	
	/**
	@note 顼ȯϥƥȤ졢Ȥϥ顼̤ݻޤ
	*/
	function assertment($file=null,$line=null,$msg=null)
	{
		$currentSuiteName = exTestSuiteUtil::currentSuiteName();
		$currentTestName = exTestSuiteUtil::currentTestName();

		$this->m_success_=false;

		// ȤϥƥȤ˵Ͽ
		$assert = new exASSERT_DATA($currentTestName,$currentSuiteName,$file,$line,$msg);
		$this->m_tests_[$currentTestName]->addAssert($assert);
		$this->m_tests_[$currentTestName]->m_countError_++;
	}
	
	function isContinueAfterFailure()
	{
		if($this->m_continueAfterFailuerFlag_)
			return true;
		else
			return $this->m_success_;
	}
	
	function total_test()
	{
		return count($this->m_tests_);
	}
	
	function total_success()
	{
		return $this->total_test() - $this->m_countError_;
	}
	
	function total_assert()
	{
		return count($this->m_assertments_);
	}

	/**
	*/
	function total_error()
	{
	}

	/**
	@brief ñΤΨ֤
	*/
	function getSuccessPer()
	{
		$total_test = $this->total_test();
		$total_success = $total_test - $this->m_countError_;
		return ceil(($total_success/$total_test)*100);
	}
	
	/**
	@brief ΤΨ֤
	*/
	function getTotalSuccessPer()
	{
		$total_test = $this->getCountTotalTest();
		$total_success = $total_test - $this->getCountTotalErrorTest();

		return ceil(($total_success/$total_test)*100);
	}
	
	/**
	@brief ۲ΥȤޤह٤Ƥμԥ顼ƥȿ֤
	*/
	function getCountTotalErrorTest()
	{
		$countError=0;
		foreach($this->m_suites_ as $suite)
			$countError+=$suite->m_countError_;

		return $countError;
	}
	
	function getCountTotalTest()
	{
		$countTest=0;
		foreach($this->m_suites_ as $suite)
			$countTest+=$suite->total_test();

		return $countTest;
	}
}

/**
@brief CppTest Ʊ褦˻Ȥλųݤ
*/
class exTestSuiteUtil
{
	function currentTestName($name=null)
	{
		static $currentTestName;
		
		if($name)
			$currentTestName=$name;

		return $currentTestName;
	}

	function currentSuiteName($name=null)
	{
		static $currentSuiteName;
		
		if($name)
			$currentSuiteName=$name;

		return $currentSuiteName;
	}
}

?>