<?php
/**
@version $Id$
*/

define ( "EXFRAME_MOJALE", 1 );
define ( "EXFRAME_TOKEN", 2 );
define ( "EXFRAME_TICKET", 2 );
define ( "EXFRAME_CONFIRM", 4 );
define ( "EXFRAME_EXXOOPS", 8 );
define ( "EXFRAME_PERM", 16 );
define ( "EXFRAME_DYNAFORM", 32 );
define ( "EXFRAME_LANG", 64 );
define ( "EXFRAME_TEST", 128 );

class exFrame {

	/**
	@brief 쥸ȥѥϥɥ
	*/
	function &getRegistryHandler() {
		global $xoopsDB;
		global $__exframe_handler_cache__;
		if(!isset($__exframe_handler_cache__['registry'])) {
			if(!class_exists("exregistryobjecthandler"))
				require_once "exTra/Registry.php";
			$__exframe_handler_cache__['registry']= new exRegistryObjectHandler($xoopsDB,"exregistryobjecthandler");
		}
		return $__exframe_handler_cache__['registry'];
	}

	// ---------
	// functions
	// ---------

	/**
	@brief ߤΥꥯȥ᥽åɤĴ POST ɤ֤饹᥽å
	*/
	function isPost() {
		return $_SERVER['REQUEST_METHOD']=='POST';
	}

	/**
	@brief ߤΥꥯȥ᥽åɤĴ GET ɤ֤饹᥽å
	*/
	function isGet() {
		return $_SERVER['REQUEST_METHOD']=='GET';
	}

	/**
	@brief ԤΤȤͤɽ
	*/
	function debug($val) {
		global $xoopsUser;
		if(is_object($xoopsUser)) {
    		if($xoopsUser->isAdmin()){
    			print nl2br(var_dump($val));
    			print "<br>";
    		}
		}
	}

	/**
	@brief XoopsFormDateTime Ǽͤ unixtime ֤ޤ
	*/
	function decodeXoopsFormDateTime($arr) {
		if(isset($arr['date']) && isset($arr['time'])) {
			$tmp=explode('-',$arr['date']);
			return mktime(0,0,0,$tmp[1],$tmp[2],$tmp[0])+$arr['time'];
		}
		else {
			return 0;
		}
	}

	/**
	@brief XoopsFormDateSelect Ǽͤ unixtime ֤ޤ
	*/
	function decodeXoopsFormDate($date) {
		$tmp=explode('-',$date);
		return mktime(0,0,0,$tmp[1],$tmp[2],$tmp[0]);
	}

	function file_get_contents($file) {
		if(!file_exists($file)) return false;

		if(function_exists("file_get_contents")) {
			return file_get_contents($file);
		}
		else {
			$ret="";

    		$fp=fopen($file,"r");
    		if(!$fp) return false;
    
			while($ret.=fread($fp,4096));
			
    		fclose($fp);
    		
    		return ($ret);
		}
	}

	/**
	@brief ꤷѥåδĶ򥻥åȥåפޤ
	*/
	function init ( $package ) {
		if( $package & EXFRAME_MOJALE )
			require_once __EXFRAME__PATH__."/mojaLE/Controller/controller.class.php";

		if( $package & EXFRAME_TOKEN )
			require_once __EXFRAME__PATH__."/include/OnetimeTicket.php";

		if( $package && EXFRAME_CONFIRM )
			require_once __EXFRAME__PATH__."/exForm/ConfirmTicketForm.php";

		if( $package && EXFRAME_EXXOOPS ) {
			require_once __EXFRAME__PATH__."/xoops/xoops.php";
			require_once __EXFRAME__PATH__."/xoops/user.php";
		}

		if( $package & EXFRAME_PERM )
			require_once __EXFRAME__PATH__."/xoops/perm.php";

		if( $package & EXFRAME_DYNAFORM ) {
			require_once __EXFRAME__PATH__."/exForm/DynaActionForm.class.php";
			require_once __EXFRAME__PATH__."/xoops/DynaXoopsForm.class.php";

			// ɲ
			if($package & EXFRAME_MOJALE)
				require_once __EXFRAME__PATH__."/mojaLE/Controller/DynaFrontController.class.php";
		}

		if( $package & EXFRAME_LANG )
			require_once __EXFRAME__PATH__."/exClass/exLang.class.php";

		if( $package & EXFRAME_TEST ) {
			require_once __EXFRAME__PATH__."/exTest/exSuite.class.php";
			require_once __EXFRAME__PATH__."/exTest/exTestRequest.class.php";
		}
	}

	function InjectionCheck($key) {
		return isset($_GET[$key]) || isset($_POST[$key]) || isset($_COOKIE[$key]) || isset($_SESSION[$key]);
	}

	function appendObjects(&$tpl,$name,&$objects) {
		foreach($objects as $obj) {
			$tpl->append(name,$obj->getStructure());
		}
	}
	
	function language($name) {
		global $xoopsConfig;
		if(isset($xoopsConfig['language'])) {
			$file=dirname(__FILE__)."/../language/".$xoopsConfig['language']."/".$name.".php";
			if(!file_exists($file))
				$file=dirname(__FILE__)."/../language/english/".$name.".php";
		}
		else
			$file=dirname(__FILE__)."/../language/english/".$name.".php";

		require_once($file);
	}
	
	/**
	@brief Ūʥåβ
	@note const.XXXX äȤ֤
	@param $string
	*/
	function MessageCatalog($string)
	{
		$ret =$string;
		if(preg_match("/^const\.(.+)$/",$string,$match)) {
			if(defined($match[1]))
				$ret = constant($match[1]);
		}
		
		return $ret;
	}

	/**
	@brief Ĥʤޤ
	@deprecated exLang 饹򻲾
	*/
	function tr($name)
	{
		global $xoopsModule;
		$suffix=str_replace(" ","_",strtoupper($name));
		$const = "_MD_".strtoupper($xoopsModule->dirname())."_LANG_".$suffix;
		if(defined($const)&&constant($const))
			return constant($const);
		else
			return $name;
	}
}

?>